<?php
session_start();
require_once '../include/libs/admin.php';
require_once path('include/libs/formatproducts.php');
class add_package extends admin{
	public function __construct(){
		$permissions = array('PERMISSION_ADD_PACKAGE');
		parent::__construct($permissions);
	}
	public function Process(){
		if(empty($_REQUEST['clientid'])){
			$this->AddError('No Client Id');
		}
		$clientdetails = $this->GetClientDetailsById($_REQUEST['clientid']);
		if(empty($_GET['orderformid'])){
			$this->AddError('No Order Form Selected');
		}else{
			$orderformid = CleanInput($_REQUEST['orderformid'], 'numeric');
		}
		if(empty($_SESSION['adminordersessionid'])){
			$sessionid = md5(rand(100000, 999999).time());
			$_SESSION['adminordersessionid'] = $sessionid;
		}else{
			$sessionid = $_SESSION['adminordersessionid'];
		}
		$productlist = '<nixbill>
			<command>GetProductList</command> 
			<orderform>'.$orderformid.'</orderform>
		</nixbill>';
		$result = $this->API($productlist);
		$getlocale = '<nixbill>
			<command>GetLocale</command> 
			<localeid>'.$result['NIXBILL'][0]['RESULT'][0]['LOCALE'][0]['VALUE'].'</localeid>
		</nixbill>';
		$locale = $this->API($getlocale);
		//print_r($locale);
		$mon = $locale['NIXBILL'][0]['RESULT'][0]['LOCALEDETAILS'][0]['LC_MONETARY'][0]['VALUE'];
		setlocale(LC_MONETARY, $mon);
		$fmt = $locale['NIXBILL'][0]['RESULT'][0]['LOCALEDETAILS'][0]['MONEYFORMAT'][0]['VALUE'];
		/**
		*
		* This section will get the tld options and list them in order.
		*
		*/
		$tldlistxml = "<nixbill>
						<command>GetTLDList</command> 
						<orderformid>".$orderformid."</orderformid>
					</nixbill>";
		$TLDListresult = $this->API($tldlistxml);
		$tldvalues = processNixArray($TLDListresult['NIXBILL'][0]['RESULT'][0]['TLDS'][0]['TLD']);
		if(count($tldvalues)==0) $this->AddTemplateVar('new', 'false');
		/**
		*
		*/
		$productcycle = CleanInput($_REQUEST['selectedcycle'], 'numeric');
		if(!empty($_GET['productid'])){
			$productid = CleanInput($_REQUEST['productid'], 'numeric');
		}else{
			$productid = $result['NIXBILL'][0]['RESULT'][0]['PRODUCT'][0]['ID'][0]['VALUE'];
		}
		$p = new formatproducts();
		$products = $p->Process($result, $productid, $productcycle);
		$this->AddTemplateVar('sessionid', $sessionid);
		$this->AddTemplateVar('orderformid', $orderformid);
		if(count($products) ==1) $this->AddTemplateVar('one', '1');
		$this->AddTemplateVar('products', $products);
		$this->AddTemplateVar('productinfo', $p->GetProductInfo());
		$this->AddTemplateVar('domainrequired', $p->GetDomainRequired());
		$this->AddTemplateVar('productcycle', $p->GetCycles());
		$this->AddTemplateVar('productaddons', $p->GetAddons());
		$this->AddTemplateVar('productaddongroups', $p->GetAddonGroups());
		$this->AddTemplateVar('clientid', CleanInput($_REQUEST['clientid'], 'numeric'));
		$this->AddTemplateVar('client', $clientdetails);	
		$this->AddTemplateVar('allowcoupons', $result['NIXBILL'][0]['RESULT'][0]['ALLOWCOUPONS'][0]['VALUE']);
		$this->AddTemplateVar('tldoptions', $tldvalues);
		$this->AddTemplateVar('tldselected', CleanInput($_REQUEST['tld'], 'text'));
		$this->AddTemplateVar('whoistype', $result['NIXBILL'][0]['RESULT'][0]['WHOISTYPE'][0]['VALUE']);
		$this->AddTemplateVar('mon', $mon);
		$this->AddTemplateVar('fmt', $fmt);
		//$submenu = array('product_add_module.php?productid='.$_GET['productid'] => 'LANG_ADD_PRODUCT_MODULE');
		//$this->AddTemplateVar('submenu', $submenu);
		$this->Display('add_domain_only.tpl');
	}
}
$go = new add_package();
$go->Process();
?>
