<?php
session_start ();
require_once '../include/libs/admin.php';
require_once path ( 'include/libs/formatproducts.php' );
class add_package extends admin {
	public function __construct() {
		$permissions = array ('PERMISSION_ADD_PACKAGE' );
		parent::__construct ( $permissions );
	}
	public function Process() {
		$inputs = $this->GetOrderFormInputs ();
		$addons = $inputs['addons'];
		$countries = countries ();
		$states = states ();
		$this->AddTemplateVar ( 'countries_selected', $countries ['selected'] );
		$this->AddTemplateVar ( 'countries_display', $countries ['name'] );
		$this->AddTemplateVar ( 'countries_value', $countries ['code'] );
		$this->AddTemplateVar ( 'states_display', $states ['name'] );
		$this->AddTemplateVar ( 'states_value', $states ['code'] );
		$this->AddTemplateVar ( 'inputs', $inputs['inputs'] );
		setlocale ( LC_MONETARY, 'en_US' );
		if (isset ( $_POST ['checkcouponcode'] )) {
			$checkcoupon = '<nixbill>
    <command>CheckCouponCode</command> 
    <productid>' . CleanInput ( $_POST ['productid'], 'numeric' ) . '</productid>
    <couponcode>' . CleanInput ( $_POST ['couponcode'], 'text' ) . '</couponcode>
</nixbill>';
			$couponresult = $this->API ( $checkcoupon );
			
			if (strlen ( $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONTYPE'] [0] ['VALUE'] ) == 1) {
				$couponaccepted = true;
				$coupontype = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONTYPE'] [0] ['VALUE'];
				$couponamount = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONAMOUNT'] [0] ['VALUE'];
				$couponcycles = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONCYCLES'] [0] ['VALUE'];
				$this->AddTemplateVar ( 'checkedcode', CleanInput ( $_POST ['couponcode'], 'text' ) );
				$this->AddTemplateVar ( 'couponcycles', $couponcycles );
			} else {
				$this->AddTemplateVar ( 'invalidcoupon', '1' );
			}
			/*echo '<pre>';
	print_r($couponresult);
	exit;*/
		}
		$productprices = '<nixbill>
	<command>GetProductPrices</command> 

	<productid>' . CleanInput ( $_POST ['productid'], 'numeric' ) . '</productid>
	<cycleid>' . CleanInput ( $_POST ['cycleid'], 'numeric' ) . '</cycleid>
</nixbill>';
		$MainProductPrice = $this->API ( $productprices );
		
		if (! is_numeric ( $MainProductPrice ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['ID'] ) || ! is_numeric ( $MainProductPrice ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['CYCLEID'] ) || ! is_numeric ( $MainProductPrice ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['PRICE'] ) || ! is_numeric ( $MainProductPrice ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['SETUP'] )) {
			/// display error template then exit
			//die('no product information found (main product)');
			error ( 'no product information found' );
		}
		
		$product ['name'] = $MainProductPrice ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['NAME'];
		$product ['cycle'] = GetCycleName ( $MainProductPrice ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['CYCLEID'] );
		$product ['price'] = _money_format ( '%(#1n', $MainProductPrice ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['PRICE'] );
		$product ['setup'] = _money_format ( '%(#1n', $MainProductPrice ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['SETUP'] );
		$tcycle = $MainProductPrice ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['CYCLEID'];
		$total [$tcycle] = $MainProductPrice ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['PRICE'];
		if ($couponaccepted) {
			$this->AddTemplateVar ( 'subtotal', _money_format ( '%(#1n', $total [$tcycle] ) );
			$this->AddTemplateVar ( 'showcoupon', '1' );
			switch ( $coupontype) {
				case 'p' :
					$_p = $total [$tcycle];
					$_c = $couponamount / 100;
					$_d = $_p * $_c;
					$coupondiscount = $_d;
					$total [$tcycle] = $total [$tcycle] - $coupondiscount;
				break;
				case 't' :
					$coupondiscount = $couponamount;
					$total [$tcycle] = $total [$tcycle] - $coupondiscount;
				break;
			}
			$this->AddTemplateVar ( 'coupondiscount', _money_format ( '%(#1n', $coupondiscount ) );
		}
		$totalSetup = $MainProductPrice ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['SETUP'];
		
		if (is_array ( $addons )) {
			foreach ( $addons as $ak => $av ) {
				if (is_numeric ( $av )) {
					$productprices = '<nixbill>
				<command>GetProductPrices</command> 
				<productid>' . $ak . '</productid>
				<cycleid>' . $av . '</cycleid>
			</nixbill>';
					$ExtraProductPrices = $this->API ( $productprices );
					if (! is_numeric ( $ExtraProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['ID'] ) || ! is_numeric ( $ExtraProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['CYCLEID'] ) || ! is_numeric ( $ExtraProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['PRICE'] ) || ! is_numeric ( $ExtraProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['SETUP'] )) {
						/// display error template then exit
						error ( 'no product information found' );
					}
					
					$addon [] = array ('name' => $ExtraProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['NAME'], 'cycle' => GetCycleName ( $ExtraProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['CYCLEID'] ), 'price' => _money_format ( '%(#1n', $ExtraProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['PRICE'] ), 'setup' => _money_format ( '%(#1n', $ExtraProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['SETUP'] ) );
					$total [$ExtraProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['CYCLEID']] = $total [$ExtraProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['CYCLEID']] + $ExtraProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['PRICE'];
					$totalSetup = $totalSetup + $ExtraProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['SETUP'];
				
				}
			}
			$this->AddTemplateVar ( 'addons', $addon );
		}
		if(CleanInput($_POST['cycleid'], 'numeric')  >= $this->Cfg ['freedomain'] && CleanInput($_POST['cycleid'], 'numeric') !=99) {$freedomain = true;}
		
		if (is_array ( $_POST ['domain'] )) {
			foreach ( $_POST ['domain'] as $name => $cycle ) {
				$domainSplit = SplitDomain ( $name );
				$tlddetails = "<nixbill>
									<command>GetTLDDetails</command> 
									<tld orderformid='" . $_POST ['orderformid'] . "' tld='" . $domainSplit ['tld'] . "'></tld>
								</nixbill>";
				$TLDresult = $this->API ( $tlddetails );
				if ($domainSplit ['tld'] == 'us') {
					$this->AddTemplateVar ( 'us_domain', '1' );
					$this->AddTemplateVar ( 'domainextra', '1' );
				}
				if ($domainSplit ['tld'] == 'co.uk') {
					$this->AddTemplateVar ( 'couk_domain', '1' );
					$this->AddTemplateVar ( 'domainextra', '1' );
				}
				if (is_numeric ( $cycle )) {
					$productprices = '<nixbill>
				<command>GetProductPrices</command> 
				<productid>' . $TLDresult ['NIXBILL'] [0] ['RESULT'] [0] ['TLD'] [0] ['PRODUCTDETAILS'] [0] ['ATTRIBUTES'] ['ID'] . '</productid>
				<cycleid>' . $cycle . '</cycleid>
			</nixbill>';
					$DomainProductPrices = $this->API ( $productprices );
					if (! is_numeric ( $DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['ID'] ) || ! is_numeric ( $DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['CYCLEID'] ) || ! is_numeric ( $DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['PRICE'] ) || ! is_numeric ( $DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['SETUP'] )) {
						/// display error template then exit
						error ( 'no product information found' );
					}
					
					if ($freedomain) {
						$DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['PRICE'] = 0;
						$freedomain = false;
					}
					$domain [] = array ('id' => $DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['ID'], 'cycle' => GetCycleName ( $DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['CYCLEID'] ), 'price' => _money_format ( '%(#1n', $DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['PRICE'] ), 'setup' => _money_format ( '%(#1n', $DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['SETUP'] ), 'sld' => $domainSplit ['sld'], 'tld' => $domainSplit ['tld'] );
					$total [$DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['CYCLEID']] = $total [$DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['CYCLEID']] + $DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['PRICE'];
					$totalSetup = $totalSetup + $DomainProductPrices ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['SETUP'];
				}
			}
			$this->AddTemplateVar ( 'domains', $domain );
		}
		
		///echo _money_format('%(#10n', $number)
		$totalduenow = 0;
		foreach ( $total as $tk => $tv ) {
			$totalamout [GetCycleName ( $tk )] = _money_format ( '%(#1n', $tv );
			$totalduenow = $totalduenow + $tv;
		}
		$totalduenow = $totalduenow + $totalSetup;
		$this->AddTemplateVar ( 'totalamount', $totalamout );
		$this->AddTemplateVar ( 'totalsetup', _money_format ( '%(#1n', $totalSetup ) );
		$this->AddTemplateVar ( 'totalduenow', _money_format ( '%(#1n', $totalduenow ) );
		$this->AddTemplateVar ( 'domaintype', $_POST ['submitteddomaintype'] );
		$billingaccounts = db::GetAllRows ( "SELECT * FROM billingaccounts WHERE clientid = '" . CleanInput ( $_REQUEST ['clientid'], 'numeric' ) . "'" );
		$this->AddTemplateVar ( 'billingaccounts', $billingaccounts );
		$this->AddTemplateVar ( 'product', $product );
		
		$this->AddTemplateVar ( 'couponallowed', $_POST ['allowcoupons'] );
		
		$clientdata = $this->GetClientDetailsById ( CleanInput ( $_REQUEST ['clientid'], 'numeric' ) );
		$this->AddTemplateVar ( 'client', $clientdata );
		$this->Display ( 'add_package_step2.tpl' );
	}
}
$go = new add_package ( );
$go->Process ();
?>
