<?php
session_start ();

/**
 * This is a single page order form system. All actions are handled by this php file. There is some code duplication in this file
 * that will be removed in later releases. This page can be saved as anything.php and run the order form. Just change the 
 * order form id to match that you want used with this file. 
 */
define ( 'SELF', 'index.php' );
/**
 * If you do not need the prototype librarys in the content pages of your site set this to '0'
 *
 */
define ( 'USE_PROTOTYPE', 0 );
/**
 * If you have the apache module 'mod_rewrite' available set this to '1' to enable it
 * This is useful for SEO
 */
define ( 'REWRITE', 0);
/**
 * Change this to show how many products to display of each page
 *
 */
define ( 'SHOW_PER_PAGE', 8 );
/**
 * Free domain. set this to the cycle id of the main product.
 * if the cycle of themain product is grater than or equal to this number, you will give away 1 free domain 
 * cycle id 6 = year
 * 
 * Domains are not currently available in the shopping cart / CMS order form. 
 * this setting does not effect anything in this part of the nixbill system
 * it will be used in the future releases
 */
$cfg ['freedomain'] = false;
/**
 * Orderform config section
 * Set the order form ID 
 */
if (! empty ( $_GET ['orderformid'] )) {
	$_SESSION ['orderformid'] = ( int ) $_GET ['orderformid'];
	define ( 'ORDERFORMID', ( int ) $_GET ['orderformid'] );
} elseif (! empty ( $_SESSION ['orderformid'] )) {
	define ( 'ORDERFORMID', ( int ) $_SESSION ['orderformid'] );
} else {
	define ( 'ORDERFORMID', 1 );
}

/**
 * Product Group (category) config section
 * Set the Group ID 
 */
if (! empty ( $_GET ['groupid'] )) {
	$_SESSION ['groupid'] = ( int ) $_GET ['groupid'];
	define ( 'GROUPID', ( int ) $_GET ['groupid'] );
} elseif (! empty ( $_SESSION ['groupid'] )) {
	define ( 'GROUPID', ( int ) $_SESSION ['groupid'] );
} /*else{
	define ( 'GROUPID', 1 );
}*/

/**
 * tmp dir for smarty templates
 * this is only needed if you use more than one order form with different templates
 * Leave it blank to use the default tmp directory
 *
 */
define ( 'TMPDIR', '' );

/**
 * Order form smarty templates
 * Set the file names of the templates here
 *
 * PAGE1PRODUCTDISPLAY 
 * main product information block on the index page
 * 
 */
define ( 'PAGE1PRODUCTDISPLAY', 'cart_orderform.tpl' );
define ( 'PRODUCTLIST', 'productlist.tpl' );
/**
 * PAGE1DOMAINDISPLAY 
 * domain section on the index page
 * 
 */
define ( 'PAGE1DOMAINDISPLAY', 'cart_domainblock.tpl' );

/**
 * PAGE1MAINTEMPLATE 
 * Main index page (wrapper to the orderform and domain block)
 * 
 */
define ( 'PAGE1MAINTEMPLATE', 'cart_product_detail.tpl' );
define ( 'PRODUCTLISTMAIN', 'cart_index.tpl' );
/**
 * VIEWCART 
 * Show the clients cart 
 * 
 */
define ( 'AJAXCART', 'cart_view_cart.tpl' );

define ( 'QUICKADD', 'cart_quickadd.tpl' );
// Dropped the static cart page. define ( 'VIEWCART', 'viewcart.tpl' );


/**
 * PAYMENTINFORMATION 
 * Second page, payment information template
 * 
 */
define ( 'PAYMENTINFORMATION', 'cart_paymentinformation.tpl' );

/**
 * PAYMENTINFORMATIONCURRENTCLIENT
 * Second page, payment information template, current client order form (must be logged in to see this one)
 * 
 */
define ( 'PAYMENTINFORMATIONCURRENTCLIENT', 'cart_paymentinformationcurrentclient.tpl' );

/**
 * ORDERCOMPLETED 
 * Last page, completed order processed with a credit card
 * 
 */
define ( 'ORDERCOMPLETED', 'cart_processorder.tpl' );

/**
 * ORDERCOMPLETEDPAYPAL
 * Last page, completed order paypal
 * 
 */
define ( 'ORDERCOMPLETEDPAYPAL', 'cart_paypal.tpl' );

/**
 * ORDERCOMPLETEDFREE 
 * Last page, completed order for a free product
 * 
 */
define ( 'ORDERCOMPLETEDFREE', 'cart_processorder_free.tpl' );
/**
 * ORDERFAILED
 * Last page, order failed
 *
 */
define ( 'ORDERFAILED', 'cart_processorderfailed.tpl' );

define ( 'ACTION', basename ( $_SERVER ['PHP_SELF'] ) );
/**
 * This xml is an example of how the order form can be set to run off a static xml file. This would not 
 * require the system to query the API each time it needed to know wha the product information is.
 * If your order form changes frequently it would be best to leave it as is.
 * This xml was generated by using the "Test API" under the system menu from NixBill admin panel
 * To produce this xml run this code in the test api
<nixbill>
    <command>GetFullOrderForm</command> 
    <orderformid>' . ORDERFORMID . '</orderformid>
</nixbill>
 * 
 * where the ORDERFORMID is the id of the orderform you will be using
 */

require_once '../include/libs/order.php';
require_once path ( 'include/libs/formatproducts_dev.php' );

class products extends order {
	private $errors = array ();
	private $paymenterrors = array ();
	public function __construct() {
		parent::__construct ( TMPDIR );
		/**
		 * Get all pages
		 */
		$pages = db::GetAllRows ( "SELECT * FROM pages WHERE status = 1 AND showinmenu = 1 ORDER BY listorder" );
		if (REWRITE == 1) {
			foreach ( $pages as $page ) {
				$display_names [] = array ('link' => $page ['pagename'], 'name' => $page ['displayname'] );
			}
			//$display_names [] = array ('link' => SELF . '?p=contactus', 'name' => 'Contact Us' );
		} else {
			foreach ( $pages as $page ) {
				$display_names [] = array ('link' => SELF . '?p=' . $page ['id'], 'name' => $page ['displayname'] );
			}
		//	$display_names [] = array ('link' => SELF . '?p=contactus', 'name' => 'Contact Us' );
		}
		
		$this->AddTemplateVar ( 'pages', $display_names );
	}
	public function Process() {
		
		$keyword = CleanInput ( $_REQUEST ['search'], 'text' );
		$productlist = '<nixbill>
    <command>GetFullOrderForm</command> 
    <orderformid>' . ORDERFORMID . '</orderformid>
    <groupid>' . GROUPID . '</groupid>';
		/**
		 * @todo 
		 * Instead of doing this, do not use this call to get the full order form when viewing the cart. use the getproduct deatails for each product to 
		 * get there information
		 */
		if ($_GET ['call'] == 'viewcart' || $_GET ['call'] == 'checkout' || $_REQUEST ['pid'] > 0) {
			$productlist .= '<limit>all</limit>';
		} else {
			$productlist .= '<limit>' . SHOW_PER_PAGE . '</limit>';
		}
		$productlist .= '<page>' . ( int ) $_REQUEST ['page'] . '</page>';
		if (isset ( $keyword )) {
			$productlist .= '<search>' . $keyword . '</search>';
			$this->AddTemplateVar ( 'keyword', $keyword );
		}
		$productlist .= '</nixbill>';
		$this->Translation ();
		$this->productarray = $this->API ( $productlist );
		//$x = new XML();
		//$this->productarray = $x->processXML(XML);
		
		if (empty ( $this->ClientId )) {
			$this->AddTemplateVar ( 'showlogin', 'true' );
		}
		$this->SetCompanyId($this->productarray ['NIXBILL'] [0] ['RESULT'] [0] ['COMPANYID'] [0] ['VALUE']);
		$this->AddTemplateVar ( 'clientname', $this->ClientDetails ['fname'] . ' ' . $this->ClientDetails ['lname'] );
		$this->AddTemplateVar ( 'category', $this->productarray ['NIXBILL'] [0] ['RESULT'] [0] ['SELECTEDGROUP'] [0] ['VALUE'] );
		foreach ( $this->productarray ['NIXBILL'] [0] ['RESULT'] [0] ['GROUPS'] [0] ['GROUP'] as $g ) {
			$categories [] = array ('id' => $g ['ID'] [0] ['VALUE'], 'name' => $g ['NAME'] [0] ['VALUE'] );
		}
		$this->AddTemplateVar ( 'categories', $categories );
		//$this->Translation ($this->productarray['NIXBILL'][0]['RESULT'][0]['LANGUAGE'][0]['VALUE']);
		define ( 'LANG', $this->productarray ['NIXBILL'] [0] ['RESULT'] [0] ['CURRENCY'] [0] ['VALUE'] );
		$this->SetSessionId ();
		$this->AddTemplateVar ( 'call', CleanInput ( $_REQUEST ['call'], 'text' ) );
		$this->SwitchPage ();
	}
	public function CheckCouponCode() {
		
		if (count ( $_REQUEST ['productids'] ) > 0) {
			foreach ( $_REQUEST ['productids'] as $pid ) {
				$checkcoupon = '<nixbill>
    <command>CheckCouponCode</command> 
    <productid>' . (int)$pid . '</productid>
    <couponcode>' . CleanInput ( $_REQUEST ['couponcode'], 'text' ) . '</couponcode>
   
</nixbill>';
				$couponresult = $this->API ( $checkcoupon );
				if (strlen ( $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONTYPE'] [0] ['VALUE'] ) == 1) {
					$couponaccepted = true;
					$coupontype = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONTYPE'] [0] ['VALUE'];
					$couponamount = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONAMOUNT'] [0] ['VALUE'];
					$couponcycles = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONCYCLES'] [0] ['VALUE'];
					//$this->AddTemplateVar ( 'checkedcode', CleanInput ( $_REQUEST ['couponcode'], 'text' ) );
					if ($coupontype == 't') {
						echo '$' . $couponamount . ' Discount off your total order-'.$couponamount;
					} else {
						echo $couponamount . '% Discount off your total order-'.$couponamount;
					}
					exit;
				} else {
					//$this->AddTemplateVar ( 'invalidcoupon', '1' );
					//	$smarty->assign('couponreason', $couponresult['NIXBILL'][0]['RESULT'][0]['COUPONREASON'][0]['VALUE']);
					if ($couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONREASON'] [0] ['VALUE']) {
						$output = str_replace ( '<br /> <a href="index.php">Click here to go back</a>', '', $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONREASON'] [0] ['VALUE'] );
						echo $output;
					} else {
						echo 0;
					}
				}
			}
		}
		return FALSE;
	
	}
	public function ValidateProducts() { // && $this->productarray['NIXBILL'][0]['RESULT'][0]['PRODUCT'][0]['DOMAINREQUIRED'][0]['VALUE']==1
		$required = array ('productid', 'cycleid' );
		if ($_POST ['submitteddomaintype'] == 'owned') {
			//$required [] = 'owneddomainsld';
			//$required [] = 'owneddomaintld';
			//$required [] = 'odomain';
			if (! preg_match ( '/^([a-zA-Z0-9]([a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])?\.)+[a-zA-Z]{2,6}$/', $_POST ['odomain'] )) {
				$this->errors [] = 'odomain';
			}
		} elseif ($_POST ['submitteddomaintype'] == 'new') {
			$required [] = 'primarydomain';
		} elseif ($_POST ['submitteddomaintype'] == 'sub') {
			$required [] = 'subdomainname';
			$required [] = 'subdomainroot';
		} /*elseif($_POST['submitteddomaintype']=='sub'){
			
		}*/
		foreach ( $required as $item ) {
			if (empty ( $_POST [$item] )) {
				$this->errors [] = $item;
			}
		}
		/*if (count ( $this->errors ) > 0)
			return false;*/
		return true;
	}
	public function Index() {
		$this->ShowPage ( 'home' );
		exit ();
	}
	public function ShowProductList() {
		$this->AddTemplateVar ( 'showleftbar', true );
		$this->Redirect ();
		if (empty ( $_SESSION ['sessionid'] )) {
			$sessionid = $this->Random ();
			$_SESSION ['sessionid'] = $sessionid;
		} else {
			$sessionid = $_SESSION ['sessionid'];
		}
		$this->AddTemplateVar ( 'showlanguage', '1' );
		$this->sessionid = $sessionid;
		$result = $this->productarray;
		//$this->productarray = $result;
		$page = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PAGINATION'] [0] ['SHOWING'] [0] ['VALUE'];
		$this->AddTemplateVar ( 'page', $page );
		$this->AddTemplateVar ( 'totalpages', $result ['NIXBILL'] [0] ['RESULT'] [0] ['PAGINATION'] [0] ['PAGES'] [0] ['VALUE'] );
		$keyword = $result ['NIXBILL'] [0] ['RESULT'] [0] ['KEYWORD'] [0] ['VALUE'];
		if ($keyword)
			$search = '&amp;search=' . $keyword;
		$this->AddTemplateVar ( 'nextpage', SELF . '?page=' . ($page + 1) . '&amp;groupid=' . GROUPID . $search );
		$this->AddTemplateVar ( 'prevpage', SELF . '?page=' . ($page - 1) . '&amp;groupid=' . GROUPID . $search );
		
		$pageinateLinks = $this->PaginateLinks ( ( int ) $_GET ['page'], ceil ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PAGINATION'] [0] ['PAGES'] [0] ['VALUE'] ) );
		$this->AddTemplateVar ( 'pageinateLinks', $pageinateLinks );
		
		for($t = 0; $t < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['TLDS'] [0] ['TLD'] ); $t ++) {
			$tldvalues [] = $result ['NIXBILL'] [0] ['RESULT'] [0] ['TLDS'] [0] ['TLD'] [$t] ['EXT'] [0] ['VALUE'];
		}
		if (! empty ( $_SERVER ['HTTP_REFERER'] ) && empty ( $_SERVER ['HTTP_REFERER'] )) {
			if (! preg_match ( '/' . $_SERVER ['HTTP_REFERER'] . '/', $this->Cfg ['baseurl'] )) {
				$_SESSION ['REFERRER'] = $_SERVER ['HTTP_REFERER'];
			}
		}
		if (count ( $this->errors ) > 0) {
			foreach ( $this->errors as $error ) {
				switch ($error) {
					case 'odomain' :
						$e [] = 'You must enter a domain name';
						break;
					case 'cycleid' :
						$e [] = 'You must select a product term option';
						break;
					case 'primarydomain' :
						$e [] = 'You must enter a domain name';
						break;
					case 'subdomainname' :
						$e [] = 'You must enter a domain name';
						break;
				}
			}
			$this->AddTemplateVar ( 'errors', $e );
		}
		if (count ( $tldvalues ) == 0) {
			$this->AddTemplateVar ( 'new', 'false' );
			$new = false;
		}
		$productcycle = CleanInput ( $_REQUEST ['cycleid'], 'numeric' );
		if (! empty ( $_REQUEST ['productid'] ) && empty ( $_REQUEST ['pid'] )) {
			$productid = ( int ) $_REQUEST ['productid'];
		
		} elseif (! empty ( $_REQUEST ['pid'] )) {
			$productid = ( int ) $_REQUEST ['pid'];
			$this->AddTemplateVar ( 'setproductid', '1' );
			$this->AddTemplateVar ( 'productid', $productid );
			
			$single = true;
		
		} else {
			$productid = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ID'] [0] ['VALUE'];
		
		}
		
		$p = new formatproducts ( );
		$products = $p->Process ( $result, $productid, $productcycle, $single );
		if (count ( $products ) == 1)
			$this->AddTemplateVar ( 'one', '1' );
		$this->AddTemplateVar ( 'products', $products );
		$this->AddTemplateVar ( 'productinfo', $p->GetProductInfo () );
		$this->AddTemplateVar ( 'domainrequired', $p->GetDomainRequired () );
		$this->AddTemplateVar ( 'productcycle', $p->GetCycles () );
		$this->AddTemplateVar ( 'productaddons', $p->GetAddons () );
		$this->AddTemplateVar ( 'productaddongroups', $p->GetAddonGroups () );
		$this->AddTemplateVar ( 'sessionid', $sessionid );
		$this->AddTemplateVar ( 'orderformid', ORDERFORMID );
		/*$nl = (isset($_GET['nixlanguage'])) ? CleanInput($_GET['nixlanguage'], 'text') : $result ['NIXBILL'] [0] ['RESULT'] [0] ['LANGUAGE'] [0] ['VALUE'];
		$this->AddTemplateVar ( 'language', $nl );*/
		$this->AddTemplateVar ( 'tldoptions', $tldvalues );
		$this->AddTemplateVar ( 'tldselected', CleanInput ( $_REQUEST ['tld'], 'text' ) );
		
		$this->AddTemplateVar ( 'allowcoupons', $result ['NIXBILL'] [0] ['RESULT'] [0] ['ALLOWCOUPONS'] [0] ['VALUE'] );
		
		$this->AddTemplateVar ( 'whoistype', $result ['NIXBILL'] [0] ['RESULT'] [0] ['WHOISTYPE'] [0] ['VALUE'] );
		$this->AddTemplateVar ( 'mon', $mon );
		$this->AddTemplateVar ( 'fmt', $fmt );
		
		$subdomains = $result ['NIXBILL'] [0] ['RESULT'] [0] ['SUBS'] [0] ['SUB'];
		if (is_array ( $subdomains )) {
			foreach ( $subdomains as $subdomain ) {
				$subs [] = $subdomain ['VALUE'];
			}
			$this->AddTemplateVar ( 'usesubs', '1' );
		}
		
		$this->AddTemplateVar ( 'subselected', CleanInput ( $_REQUEST ['subroot'], 'text' ) );
		$this->AddTemplateVar ( 'subdomains', $subs );
		if ($_POST ['call'] == 'loadform') {
			$domainS = $this->_getsessiondomains ( $productcycle );
			$this->AddTemplateVar ( 'sessiondomains', $domainS );
			foreach ( $_REQUEST as $rk => $rv ) {
				$vars [$rk] = CleanInput ( $rv, 'text' );
			
			}
			if (empty ( $vars ['submitteddomaintype'] ) && count ( $tldvalues ) == 0) {
				$vars ['submitteddomaintype'] = 'owned';
			} elseif (empty ( $vars ['submitteddomaintype'] ) && count ( $tldvalues ) > 0) {
				$vars ['submitteddomaintype'] = 'new';
			}
			$this->AddTemplateVar ( 'vars', $vars );
			//$this->Display ( PAGE1PRODUCTDISPLAY );
			$this->Display ( PRODUCTLIST );
		} elseif ($_REQUEST ['call'] == 'loaddomain') {
			
			$this->Display ( PAGE1DOMAINDISPLAY );
		} else {
			$this->AddTemplateVar ( 'companyinfo', $this->GetCompanyInfoById ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['COMPANYID'] [0] ['VALUE'] ) );
			$this->AddTemplateVar ( 'title', $result ['NIXBILL'] [0] ['RESULT'] [0] ['TITLE'] [0] ['VALUE'] );
			
			$this->Display ( PRODUCTLISTMAIN );
		}
	}
	public function ProductDetails($pid) {
		$this->AddTemplateVar ( 'showleftbar', true );
		$this->Redirect ();
		if (empty ( $_SESSION ['sessionid'] )) {
			$sessionid = $this->Random ();
			$_SESSION ['sessionid'] = $sessionid;
		} else {
			$sessionid = $_SESSION ['sessionid'];
		}
		$this->AddTemplateVar ( 'showlanguage', '1' );
		$this->sessionid = $sessionid;
		$result = $this->productarray;
		//$this->productarray = $result;
		for($t = 0; $t < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['TLDS'] [0] ['TLD'] ); $t ++) {
			$tldvalues [] = $result ['NIXBILL'] [0] ['RESULT'] [0] ['TLDS'] [0] ['TLD'] [$t] ['EXT'] [0] ['VALUE'];
		}
		if (! empty ( $_SERVER ['HTTP_REFERER'] ) && empty ( $_SERVER ['HTTP_REFERER'] )) {
			if (! preg_match ( '/' . $_SERVER ['HTTP_REFERER'] . '/', $this->Cfg ['baseurl'] )) {
				$_SESSION ['REFERRER'] = $_SERVER ['HTTP_REFERER'];
			}
		}
		if (count ( $this->errors ) > 0) {
			foreach ( $this->errors as $error ) {
				switch ($error) {
					case 'odomain' :
						$e [] = 'You must enter a domain name';
						break;
					case 'cycleid' :
						$e [] = 'You must select a product term option';
						break;
					case 'primarydomain' :
						$e [] = 'You must enter a domain name';
						break;
					case 'subdomainname' :
						$e [] = 'You must enter a domain name';
						break;
				}
			}
			$this->AddTemplateVar ( 'errors', $e );
		}
		if (count ( $tldvalues ) == 0) {
			$this->AddTemplateVar ( 'new', 'false' );
			$new = false;
		}
		$productcycle = CleanInput ( $_REQUEST ['cycleid'], 'numeric' );
		
		$productid = $pid;
		$this->AddTemplateVar ( 'setproductid', '1' );
		$this->AddTemplateVar ( 'productid', $productid );
		$single = true;
		
		$p = new formatproducts ( );
		$products = $p->Process ( $result, $productid, $productcycle, $single );
		
		if (count ( $products ) == 1)
			$this->AddTemplateVar ( 'one', '1' );
		
		$this->AddTemplateVar ( 'products', $products );
		$this->AddTemplateVar ( 'productinfo', $p->GetProductInfo () );
		$this->AddTemplateVar ( 'domainrequired', $p->GetDomainRequired () );
		$this->AddTemplateVar ( 'productcycle', $p->GetCycles () );
		$this->AddTemplateVar ( 'productaddons', $p->GetAddons () );
		$this->AddTemplateVar ( 'productaddongroups', $p->GetAddonGroups () );
		$this->AddTemplateVar ( 'sessionid', $sessionid );
		$this->AddTemplateVar ( 'orderformid', ORDERFORMID );
		/*$nl = (isset($_GET['nixlanguage'])) ? CleanInput($_GET['nixlanguage'], 'text') : $result ['NIXBILL'] [0] ['RESULT'] [0] ['LANGUAGE'] [0] ['VALUE'];
		$this->AddTemplateVar ( 'language', $nl );*/
		$this->AddTemplateVar ( 'tldoptions', $tldvalues );
		$this->AddTemplateVar ( 'tldselected', CleanInput ( $_REQUEST ['tld'], 'text' ) );
		
		$this->AddTemplateVar ( 'allowcoupons', $result ['NIXBILL'] [0] ['RESULT'] [0] ['ALLOWCOUPONS'] [0] ['VALUE'] );
		
		$this->AddTemplateVar ( 'whoistype', $result ['NIXBILL'] [0] ['RESULT'] [0] ['WHOISTYPE'] [0] ['VALUE'] );
		$this->AddTemplateVar ( 'mon', $mon );
		$this->AddTemplateVar ( 'fmt', $fmt );
		
		$subdomains = $result ['NIXBILL'] [0] ['RESULT'] [0] ['SUBS'] [0] ['SUB'];
		if (is_array ( $subdomains )) {
			foreach ( $subdomains as $subdomain ) {
				$subs [] = $subdomain ['VALUE'];
			}
			$this->AddTemplateVar ( 'usesubs', '1' );
		}
		$this->AddTemplateVar ( 'subselected', CleanInput ( $_REQUEST ['subroot'], 'text' ) );
		$this->AddTemplateVar ( 'subdomains', $subs );
		if ($_POST ['call'] == 'loadform') {
			$domainS = $this->_getsessiondomains ( $productcycle );
			$this->AddTemplateVar ( 'sessiondomains', $domainS );
			foreach ( $_REQUEST as $rk => $rv ) {
				$vars [$rk] = CleanInput ( $rv, 'text' );
			
			}
			if (empty ( $vars ['submitteddomaintype'] ) && count ( $tldvalues ) == 0) {
				$vars ['submitteddomaintype'] = 'owned';
			} elseif (empty ( $vars ['submitteddomaintype'] ) && count ( $tldvalues ) > 0) {
				$vars ['submitteddomaintype'] = 'new';
			}
			$this->AddTemplateVar ( 'vars', $vars );
			/*if ($_REQUEST ['ajax'] == '1') {
				$this->Display ( QUICKADD );
			} else {
			$this->Display ( PAGE1PRODUCTDISPLAY );
			}*/
			
			$this->Display ( PAGE1PRODUCTDISPLAY );
			//$this->Display ( QUICKADD );
		} elseif ($_REQUEST ['call'] == 'loaddomain') {
			
			$this->Display ( PAGE1DOMAINDISPLAY );
		} else {
			$this->AddTemplateVar ( 'companyinfo', $this->GetCompanyInfoById ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['COMPANYID'] [0] ['VALUE'] ) );
			$this->AddTemplateVar ( 'title', $result ['NIXBILL'] [0] ['RESULT'] [0] ['TITLE'] [0] ['VALUE'] );
			if ($_REQUEST ['ajax'] == '1') {
				
				$this->Display ( QUICKADD );
			} else {
				
				$this->Display ( PAGE1MAINTEMPLATE );
			}
		}
	}
	
	public function ProcessOrder() {
		/*echo '<pre>';
		print_r($_POST);
		echo '</pre>';
		exit;*/
		$this->AddTemplateVar ( 'showleftbar', true );
		$this->Redirect ();
		$result = $this->productarray;
		if (preg_match ( '/^baid/', $_POST ['paymenttype'] ) && ! empty ( $this->ClientId )) {
			$baid = explode ( '_', $_POST ['paymenttype'] );
			$billingaccountid = ( int ) $baid [1];
			$paymenttype = 1;
		} else {
			$paymenttype = ( int ) $_POST ['paymenttype'];
		}
		
		$sessionid = $this->GetSessionId ();
		$getcartxml = "<nixbill>
		<command>GetCart</command>
		<sessionid>" . $sessionid . "</sessionid>
		</nixbill>";
		$cart = $this->API ( $getcartxml );
		
		if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['FRAUDID'] [0] ['VALUE'] > 0 && empty ( $this->ClientId )) {
			$emaildomain = explode ( '@', CleanInput ( $_POST ['email1'], 'text' ) );
			$usefraud = '<usefraud>1</usefraud>';
			
			$processfraud = '<nixbill>
				<command>ProcessFraud</command> 
				
				<moduleid>' . $result ['NIXBILL'] [0] ['RESULT'] [0] ['FRAUDID'] [0] ['VALUE'] . '</moduleid>
				<clientdetails>
					<firstname>' . CleanInput ( $_POST ['fname'], 'text' ) . '</firstname>
					<lastname>' . CleanInput ( $_POST ['lname'], 'text' ) . '</lastname>
					<city>' . CleanInput ( $_POST ['city'], 'text' ) . '</city>
					<zipcode>' . CleanInput ( $_POST ['zipcode'], 'text' ) . '</zipcode>
					<region>' . CleanInput ( $_POST ['state'], 'text' ) . '</region>
					<ip>' . $_SERVER ['REMOTE_ADDR'] . '</ip>
					<country>' . CleanInput ( $_POST ['country'], 'text' ) . '</country>
					<phone>' . CleanInput ( $_POST ['phone1'], 'numeric' ) . '</phone>
					<domain>' . $emaildomain [1] . '</domain>
					<email>' . CleanInput ( $_POST ['email1'], 'text' ) . '</email>
					<forwardip>' . $_SERVER ['HTTP_X_FORWARDED'] . '</forwardip>
					<username>' . md5 ( CleanInput ( $_POST ['username'], 'text' ) ) . '</username>
					<password>' . md5 ( CleanInput ( $_POST ['password'], 'text' ) ) . '</password>
					
				</clientdetails>
				</nixbill>';
			$fraudresult = $this->API ( $processfraud );
			
			$fraudresultxml = '<fraudresults>'; /// need to put error checking here incase there is a failure on the fraud module.
			if (is_array ( $fraudresult ['NIXBILL'] [0] ['RESULT'] [0] ['FRAUDRETURN'] [0] )) {
				foreach ( $fraudresult ['NIXBILL'] [0] ['RESULT'] [0] ['FRAUDRETURN'] [0] as $fk => $fv ) {
					$fraudresultxml .= '<' . $fk . '>' . $fv [0] ['VALUE'] . '</' . $fk . '>
		';
				}
			}
			$fraudresultxml .= '</fraudresults>';
		}
		
		$processorder = '<nixbill> 
	<command>CreateOrder</command> 
	<paymenttype>' . $paymenttype . '</paymenttype>
	<paymentfunction>sale</paymentfunction>
	<orderform>' . ORDERFORMID . '</orderform>
	' . $usefraud . '
	<clientdetails>';
		if ($this->ClientId) {
			$processorder .= '
			<clientid>' . $this->ClientId . '</clientid>
			<username>' . $this->ClientDetails ['email'] . '</username>
			<password>' . $this->ClientDetails ['password'] . '</password>';
		} else {
			$processorder .= '
			<username>' . CleanInput ( $_POST ['username'], 'text' ) . '</username>
			<password>' . CleanInput ( $_POST ['password'], 'text' ) . '</password>
			';
		}
		$processorder .= '<billingaccountid>' . $billingaccountid . '</billingaccountid>
		<firstname>' . CleanInput ( $_POST ['fname'], 'text' ) . '</firstname>
		<lastname>' . CleanInput ( $_POST ['lname'], 'text' ) . '</lastname>
		
		<email1>' . CleanInput ( $_POST ['email1'], 'text' ) . '</email1>
		<email2>' . CleanInput ( $_POST ['email2'], 'text' ) . '</email2>
		<address1>' . CleanInput ( $_POST ['address1'], 'text' ) . '</address1>
		<address2>' . CleanInput ( $_POST ['address2'], 'text' ) . '</address2>
		<city>' . CleanInput ( $_POST ['city'], 'text' ) . '</city>
		<state>' . CleanInput ( $_POST ['state'], 'text' ) . '</state>
		<zipcode>' . CleanInput ( $_POST ['zipcode'], 'text' ) . '</zipcode>
		<country>' . CleanInput ( $_POST ['country'], 'text' ) . '</country>
		<phone1>' . CleanInput ( $_POST ['phone1'], 'numeric' ) . '</phone1>
		<phone2>' . CleanInput ( $_POST ['phone2'], 'numeric' ) . '</phone2>
		<company>' . CleanInput ( $_POST ['company'], 'text' ) . '</company>
		<cardnumber>' . CleanInput ( $_POST ['cardnumber'], 'numeric' ) . '</cardnumber>
		<firstnameoncard>' . CleanInput ( $_POST ['firstnameoncard'], 'text' ) . '</firstnameoncard>
		<lastnameoncard>' . CleanInput ( $_POST ['lastnameoncard'], 'text' ) . '</lastnameoncard>
		<carddate>' . CleanInput ( $_POST ['ExpMonth'], 'numeric' ) . substr ( CleanInput ( $_POST ['ExpYear'], 'numeric' ), 2, 2 ) . '</carddate>
		<cardtype>' . CleanInput ( $_POST [''], 'text' ) . '</cardtype> 
		<cardcvv2>' . CleanInput ( $_POST ['cvv2'], 'numeric' ) . '</cardcvv2>
		<language>' . CleanInput ( $_POST ['language'], 'text' ) . '</language>
		<companyid>' . CleanInput ( $_POST [''], 'numeric' ) . '</companyid>
		
		<signupip>' . $_SERVER ['REMOTE_ADDR'] . '</signupip>
		<referrer>' . $_SESSION ['REFERRER'] . '</referrer>
		<affiliatetracker>' . $_SESSION ['tracker'] . '</affiliatetracker>
		<status>0</status>
	</clientdetails>';
		
		$processorder .= $fraudresultxml;
		
		/**
		 * begin cart loop
		 */
		
		$items = $cart ['NIXBILL'] [0] ['RESULT'] [0] ['ITEMS'] [0] ['ITEM'];
		for($i = 0; $i < count ( $items ); $i ++) {
			$productprices = '<nixbill>
	<command>GetProductPrices</command> 
	<productid>' . ( int ) $items [$i] ['PRIMARY'] [0] ['PRODUCTID'] [0] ['VALUE'] . '</productid>
	<cycleid>' . ( int ) $items [$i] ['PRIMARY'] [0] ['CYCLEID'] [0] ['VALUE'] . '</cycleid>
</nixbill>';
			$productpriceresult = $this->API ( $productprices );
			
			$processorder .= '	<orderdetails>
		<productid>' . ( int ) $items [$i] ['PRIMARY'] [0] ['PRODUCTID'] [0] ['VALUE'] . '</productid>
		<cycleid>' . ( int ) $items [$i] ['PRIMARY'] [0] ['CYCLEID'] [0] ['VALUE'] . '</cycleid>
		<quantity>' . ( int ) $items [$i] ['PRIMARY'] [0] ['QUANTITY'] [0] ['VALUE'] . '</quantity>
		<price>' . $productpriceresult ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['PRICE'] . '</price>
		<setup>' . $productpriceresult ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['SETUP'] . '</setup>';
			$processorder .= '		<couponcode>' . CleanInput ( $_POST ['couponcode'], 'text' ) . '</couponcode>';
			$processorder .= '	</orderdetails>';
			
			if (is_array ( $items [$i] ['EXTRAS'] [0] ['EXTRA'] )) {
				foreach ( $items [$i] ['EXTRAS'] [0] ['EXTRA'] as $extra ) {
					$productprices = '<nixbill>
	<command>GetProductPrices</command> 
	<productid>' . ( int ) $extra ['PRODUCTID'] [0] ['VALUE'] . '</productid>
	<cycleid>' . ( int ) $extra ['CYCLEID'] [0] ['VALUE'] . '</cycleid>
</nixbill>';
					$productpriceresult = $this->API ( $productprices );
					
					$processorder .= '	<orderdetails>
		<productid>' . ( int ) $extra ['PRODUCTID'] [0] ['VALUE'] . '</productid>
		<cycleid>' . ( int ) $extra ['CYCLEID'] [0] ['VALUE'] . '</cycleid>
		<quantity>' . ( int ) $extra ['QUANTITY'] [0] ['VALUE'] . '</quantity>
		<parent>' . ( int ) $extra ['PARENTCARTITEMID'] [0] ['VALUE'] . '</parent>
		<price>' . $productpriceresult ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['PRICE'] . '</price>
		<setup>' . $productpriceresult ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ATTRIBUTES'] ['SETUP'] . '</setup>';
					$processorder .= '		<couponcode>' . CleanInput ( $_POST ['couponcode'], 'text' ) . '</couponcode>';
					$processorder .= '	</orderdetails>';
				}
			}
		
		}
		
		/**
		 * END cart loop
		 */
		
		$processorder .= '</nixbill>';
		/*header ( "Content-type: text/xml" );
		print_r ( $processorder );
		exit ();*/
		$result = $this->API ( $processorder );
		
		$clientid = $result ['NIXBILL'] [0] ['RESULT'] [0] [CLIENTID] [0] [VALUE];
		$invoiceid = $result ['NIXBILL'] [0] ['RESULT'] [0] ['INVOICE'] [0] [INVOICEID] [0] [VALUE];
		$total = $result ['NIXBILL'] [0] ['RESULT'] [0] ['INVOICE'] [0] [TOTAL] [0] [VALUE];
		$setup = $result ['NIXBILL'] [0] ['RESULT'] [0] ['INVOICE'] [0] [SETUP] [0] [VALUE];
		$tax = $result ['NIXBILL'] [0] ['RESULT'] [0] ['INVOICE'] [0] [TAX] [0] [VALUE];
		$subtotal = $result ['NIXBILL'] [0] ['RESULT'] [0] ['INVOICE'] [0] [SUBTOTAL] [0] [VALUE];
		$grandtotal = $result ['NIXBILL'] [0] ['RESULT'] [0] ['INVOICE'] [0] [GRANDTOTAL] [0] [VALUE];
		$paymenttype = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] [PAYMENTTYPE] [0] [VALUE];
		
		$this->AddTemplateVar ( 'clientid', $clientid );
		$this->AddTemplateVar ( 'invoiceid', $invoiceid );
		$this->AddTemplateVar ( 'total', $total );
		$this->AddTemplateVar ( 'setup', $setup );
		$this->AddTemplateVar ( 'tax', $tax );
		$this->AddTemplateVar ( 'subtotal', $subtotal );
		$this->AddTemplateVar ( 'grandtotal', $grandtotal );
		$this->AddTemplateVar ( 'paymenttype', $paymenttype );
		$this->AddTemplateVar ( 'title', $orderformdetails ['NIXBILL'] [0] ['RESULT'] [0] ['ORDERFORMDETAILS'] [0] ['TITLE'] [0] ['VALUE'] );
		switch ($paymenttype) {
			case 1 :
				$billingaccountid = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['BILLINGACCOUNTID'];
				$transactionid = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['TRANSID'];
				$transactionstatus = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['STATUS'];
				$avs = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['AVS'];
				$cvv2 = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['CVV2'];
				$authcode = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['AUTHCODE'];
				$message = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['MESSAGE'];
				$rebid = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['REBID'];
				$this->AddTemplateVar ( 'billingaccountid', $billingaccountid );
				$this->AddTemplateVar ( 'transactionid', $transactionid );
				$this->AddTemplateVar ( 'transactionstatus', $transactionstatus );
				$this->AddTemplateVar ( 'avs', $avs );
				$this->AddTemplateVar ( 'authcode', $authcode );
				$this->AddTemplateVar ( 'message', $message );
				$this->AddTemplateVar ( 'rebid', $rebid );
				if ($transactionstatus == 1) {
					$template = ORDERCOMPLETED;
					$this->EmptyCart ();
				} else {
					$template = ORDERFAILED;
				}
				break;
			case 2 :
				$paypallinks = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['PAYPALLINKS'] [0] ['PAYPALLINK'];
				$onetime = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['PAYPALONETIMELINK'] [0] ['VALUE'];
				$this->AddTemplateVar ( 'paypalonetime', base64_decode ( $onetime ) );
				if (is_array ( $paypallinks )) {
					foreach ( $paypallinks as $link ) {
						$paypaldecodedlinks [] = base64_decode ( $link ['VALUE'] );
					}
				}
				$this->AddTemplateVar ( 'paypallinks', $paypaldecodedlinks );
				$template = ORDERCOMPLETEDPAYPAL;
				$this->EmptyCart ();
				break;
			case 3 :
				break;
		}
		if (empty ( $template )) {
			$template = ORDERCOMPLETEDFREE;
		}
		
		$this->Display ( $template );
	}
	
	/**
	 * @name Checkout function
	 */
	public function CheckOut($e = false) {
		$this->AddTemplateVar ( 'showleftbar', true );
		$this->Redirect ();
		$sessionid = $this->GetSessionId ();
		/*echo '<pre>';
		print_r($_POST);
		exit;*/
		/**
		 * Query the API to get the cart contents
		 */
		//
		unset ( $_POST ['tos'] );
		unset ( $_POST ['paymenttype'] );
		
		$errors = $e ['NIXBILL'] [0] ['RESULT'] [0] ['ERRORS'] [0] ['ERROR'];
		
		if (count ( $errors ) > 0) {
			foreach ( $errors as $error ) {
				$e_name [] = constant ( $error ['VALUE'] );
			}
			
			$this->AddTemplateVar ( 'errors', $e_name );
		}
		/*echo '<pre>';
			print_r($errors);
		echo '</pre>';*/
		$result = $this->productarray;
		/*echo '<pre>';
			print_r($result);
		echo '</pre>';*/
		$this->AddTemplateVar ( 'couponallowed', $result ['NIXBILL'] [0] ['RESULT'] [0] ['ALLOWCOUPONS'] [0] ['VALUE'] );
		$this->AddTemplateVar ( 'sessionid', $sessionid );
		$this->AddTemplateVar ( 'cc', $result ['NIXBILL'] [0] ['RESULT'] [0] ['ACCEPTCC'] [0] ['VALUE'] );
		$this->AddTemplateVar ( 'pp', $result ['NIXBILL'] [0] ['RESULT'] [0] ['ACCEPTPP'] [0] ['VALUE'] );
		$countries = countries ();
		$states = states ();
		$this->AddTemplateVar ( 'countries_selected', $countries ['selected'] );
		$this->AddTemplateVar ( 'countries_display', $countries ['name'] );
		$this->AddTemplateVar ( 'countries_value', $countries ['code'] );
		$this->AddTemplateVar ( 'states_display', $states ['name'] );
		$this->AddTemplateVar ( 'states_value', $states ['code'] );
		$this->AddTemplateVar ( 'title', $result ['NIXBILL'] [0] ['RESULT'] [0] ['TITLE'] [0] ['VALUE'] );
		
		setlocale ( LC_MONETARY, CleanInput ( $_REQUEST ['mon'], 'text' ) );
		$fmt = CleanInput ( $_REQUEST ['fmt'], 10 );
		if (isset ( $_POST ['checkcouponcode'] )) {
			/*echo '<pre>';
			print_r($_POST);
		echo '</pre>';*/
			$checkcoupon = '<nixbill>
    <command>CheckCouponCode</command> 
    <productid>' . CleanInput ( $_POST ['productid'], 'numeric' ) . '</productid>
    <couponcode>' . CleanInput ( $_POST ['couponcode'], 'text' ) . '</couponcode>
</nixbill>';
			$couponresult = $this->API ( $checkcoupon );
			if (strlen ( $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONTYPE'] [0] ['VALUE'] ) == 1) {
				$couponaccepted = true;
				$coupontype = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONTYPE'] [0] ['VALUE'];
				$couponamount = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONAMOUNT'] [0] ['VALUE'];
				$couponcycles = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONCYCLES'] [0] ['VALUE'];
				$this->AddTemplateVar ( 'checkedcode', CleanInput ( $_POST ['couponcode'], 'text' ) );
			} else {
				$this->AddTemplateVar ( 'invalidcoupon', '1' );
			}
		
		}
		//
		$total = array ();
		$getcartxml = "<nixbill>
		<command>GetCart</command>
		<sessionid>" . $sessionid . "</sessionid>
		</nixbill>";
		$cart = $this->API ( $getcartxml );
		$result = $this->productarray;
		/*echo '<!--';
		print_r ( $cart );
		echo '-->';*/
		$this->AddTemplateVar ( 'sessionid', $sessionid );
		$this->AddTemplateVar ( 'title', $result ['NIXBILL'] [0] ['RESULT'] [0] ['TITLE'] [0] ['VALUE'] );
		setlocale ( LC_MONETARY, CleanInput ( $_REQUEST ['mon'], 'text' ) );
		$fmt = CleanInput ( $_REQUEST ['fmt'], 10 );
		if (isset ( $_POST ['checkcouponcode'] )) {
			$checkcoupon = '<nixbill>
    <command>CheckCouponCode</command> 
    <productid>' . CleanInput ( $_POST ['productid'], 'numeric' ) . '</productid>
    <couponcode>' . CleanInput ( $_POST ['couponcode'], 'text' ) . '</couponcode>
</nixbill>';
			$couponresult = $this->API ( $checkcoupon );
			if (strlen ( $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONTYPE'] [0] ['VALUE'] ) == 1) {
				$couponaccepted = true;
				$coupontype = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONTYPE'] [0] ['VALUE'];
				$couponamount = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONAMOUNT'] [0] ['VALUE'];
				$couponcycles = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONCYCLES'] [0] ['VALUE'];
				$this->AddTemplateVar ( 'checkedcode', CleanInput ( $_POST ['couponcode'], 'text' ) );
			} else {
				$this->AddTemplateVar ( 'invalidcoupon', '1' );
			}
		
		}
		/**
		 * starting here we need to loop this section.
		 * this will list all items in the cart seperatly
		 */
		
		for($ci = 0; $ci < count ( $cart ['NIXBILL'] [0] ['RESULT'] [0] ['ITEMS'] [0] ['ITEM'] ); $ci ++) {
			$item = $cart ['NIXBILL'] [0] ['RESULT'] [0] ['ITEMS'] [0] ['ITEM'] [$ci];
			for($pk = 0; $pk < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] ); $pk ++) {
				if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$pk] ['ID'] [0] ['VALUE'] == $item ['PRIMARY'] [0] ['PRODUCTID'] [0] ['VALUE']) {
					$productkey = $pk;
				}
			}
			for($ck = 0; $ck < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] ); $ck ++) {
				if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$ck] ['ID'] [0] ['VALUE'] == $item ['PRIMARY'] [0] ['CYCLEID'] [0] ['VALUE']) {
					$cyclekey = $ck;
				}
			}
			$product ['cartid'] = $item ['PRIMARY'] [0] ['ID'] [0] ['VALUE'];
			$product ['quantity'] = $item ['PRIMARY'] [0] ['QUANTITY'] [0] ['VALUE'];
			$product ['image'] = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['IMAGE'] [0] ['VALUE'];
			$product ['id'] = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ID'] [0] ['VALUE'];
			$product ['name'] = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['NAME'] [0] ['VALUE'];
			$product ['cycle'] = GetCycleName ( $item ['PRIMARY'] [0] ['CYCLEID'] [0] ['VALUE'] );
			$product ['price'] = _money_format ( $fmt, ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$cyclekey] ['PRICE'] [0] ['VALUE'] * $item ['PRIMARY'] [0] ['QUANTITY'] [0] ['VALUE']) );
			$product ['singleprice'] = _money_format ( $fmt, $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$cyclekey] ['PRICE'] [0] ['VALUE'] );
			$product ['setup'] = _money_format ( $fmt, $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$cyclekey] ['SETUP'] [0] ['VALUE'] );
			$products [] = $product;
			$coupon_product_ids[] = $product ['id'];
			$tcycle = $item ['PRIMARY'] [0] ['CYCLEID'] [0] ['VALUE'];
			$total [$tcycle] = $total [$tcycle] + ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$cyclekey] ['PRICE'] [0] ['VALUE'] * $product ['quantity']);
			if ($couponaccepted) {
				$this->AddTemplateVar ( 'subtotal', _money_format ( $fmt, $total [$tcycle] ) );
				$this->AddTemplateVar ( 'showcoupon', '1' );
				switch ($coupontype) {
					case 'p' :
						$_p = $total [$tcycle];
						$_c = $couponamount / 100;
						$_d = $_p * $_c;
						$coupondiscount = $_d;
						$total [$tcycle] = $total [$tcycle] - $coupondiscount;
						break;
					case 't' :
						$coupondiscount = $couponamount;
						$total [$tcycle] = $total [$tcycle] - $coupondiscount;
						break;
				}
				$this->AddTemplateVar ( 'coupondiscount', _money_format ( $fmt, $coupondiscount ) );
			}
			$totalSetup = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$cyclekey] ['SETUP'] [0] ['VALUE'];
			if (is_array ( $item ['EXTRAS'] [0] ['EXTRA'] )) {
				foreach ( $item ['EXTRAS'] [0] ['EXTRA'] as $ek => $extra ) {
					
					for($addk = 0; $addk < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] ); $addk ++) {
						if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$addk] ['ADDON'] [0] ['ID'] [0] ['VALUE'] == $extra ['PRODUCTID'] [0] ['VALUE']) {
							$groupkey = $addk;
						}
					}
					
					for($ck = 0; $ck < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] ); $ck ++) {
						if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$ck] ['ID'] [0] ['VALUE'] == $extra ['PRODUCTID'] [0] ['VALUE']) {
							$addonkey = $ck;
						}
					}
					for($ck = 0; $ck < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] ); $ck ++) {
						if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$ck] ['ID'] [0] ['VALUE'] == $extra ['CYCLEID'] [0] ['VALUE']) {
							$addoncyclekey = $ck;
						}
					}
					
					$addon [] = array ('id' => $extra ['PRODUCTID'] [0] ['VALUE'], 'cartid' => $extra ['ID'] [0] ['VALUE'], 'name' => $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['NAME'] [0] ['VALUE'], 'cycle' => GetCycleName ( $extra ['CYCLEID'] [0] ['VALUE'] ), 'quantity' => $extra ['QUANTITY'] [0] ['VALUE'], 'price' => _money_format ( $fmt, ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$addoncyclekey] ['PRICE'] [0] ['VALUE'] * $extra ['QUANTITY'] [0] ['VALUE']) ), 'singleprice' => _money_format ( $fmt, $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$addoncyclekey] ['PRICE'] [0] ['VALUE'] ), 'setup' => _money_format ( $fmt, $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$addoncyclekey] ['SETUP'] [0] ['VALUE'] ) );
					$total [$extra ['CYCLEID'] [0] ['VALUE']] = $total [$extra ['CYCLEID'] [0] ['VALUE']] + ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$addoncyclekey] ['PRICE'] [0] ['VALUE'] * $extra ['QUANTITY'] [0] ['VALUE']);
					$totalSetup = $totalSetup + $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$addoncyclekey] ['SETUP'] [0] ['VALUE'];
				
				}
			
			}
			if ($item ['PRIMARY'] [0] ['CYCLEID'] [0] ['VALUE'] >= $this->Cfg ['freedomain'] && is_numeric ( $this->Cfg ['freedomain'] )) {
				$freedomain = true;
			}
			
			$tldarray = $result ['NIXBILL'] [0] ['RESULT'] [0] ['TLDS'] [0] ['TLD'];
			if (is_array ( $item ['EXTRAS'] [0] ['DOMAIN'] )) {
				foreach ( $item ['EXTRAS'] [0] ['DOMAIN'] as $dk => $domainarray ) {
					
					$domainSplit = SplitDomain ( $domainarray ['DOMAIN'] [0] ['VALUE'] );
					for($ftk = 0; $ftk < count ( $tldarray ); $ftk ++) {
						if ($tldarray [$ftk] ['EXT'] [0] ['VALUE'] == $domainSplit ['tld'])
							$tldkey = $ftk;
					}
					if (is_array ( $tldarray [$tldkey] ['CYCLES'] [0] ['CYCLE'] )) {
						foreach ( $tldarray [$tldkey] ['CYCLES'] [0] ['CYCLE'] as $tk => $tv ) {
							if ($tv ['ID'] [0] ['VALUE'] == $domainarray ['CYCLEID'] [0] ['VALUE']) {
								$tld = $tv;
							}
						}
					}
					if ($domainSplit ['tld'] == 'us') {
						$this->AddTemplateVar ( 'us_domain', '1' );
						$this->AddTemplateVar ( 'domainextra', '1' );
					}
					if ($domainSplit ['tld'] == 'co.uk') {
						$this->AddTemplateVar ( 'couk_domain', '1' );
						$this->AddTemplateVar ( 'domainextra', '1' );
					}
					if (is_numeric ( $domainarray ['CYCLEID'] [0] ['VALUE'] )) {
						if ($freedomain) {
							$tld ['PRICE'] [0] ['VALUE'] = 0;
							$freedomain = false;
						}
						
						$domain [] = array ('cartid' => $domainarray ['ID'] [0] ['VALUE'], 'id' => $tld ['ID'] [0] ['VALUE'], 'cycle' => GetCycleName ( $tld ['ID'] [0] ['VALUE'] ), 'price' => _money_format ( $fmt, $tld ['PRICE'] [0] ['VALUE'] ), 'setup' => _money_format ( $fmt, $tld ['SETUP'] [0] ['VALUE'] ), 'sld' => $domainSplit ['sld'], 'tld' => $domainSplit ['tld'] );
						$total [$tld ['ID'] [0] ['VALUE']] = $total [$tld ['ID'] [0] ['VALUE']] + $tld ['PRICE'] [0] ['VALUE'];
						$totalSetup = $totalSetup + $tld ['SETUP'] [0] ['VALUE'];
					}
				}
			
			}
			$addons [] = $addon;
			$out [] = array ('product' => $product, 'addon' => $addon, 'domain' => $domain, 'totalsetup' => $totalSetup, 'total' => $total );
			unset ( $domain );
			unset ( $addon );
			unset ( $product );
		
		}
		$this->AddTemplateVar ( 'couponproductids',$coupon_product_ids);
		$this->AddTemplateVar ( 'productdata', $out );
		foreach ( $total as $tk => $tv ) {
			$totalamout [GetCycleName ( $tk )] = _money_format ( $fmt, $tv );
			$totalduenow = $totalduenow + $tv;
		}
		$totalduenow = $totalduenow + $totalSetup;
		$this->AddTemplateVar ( 'products', $products );
		$this->AddTemplateVar ( 'addons', $addons [0] );
		
		$this->AddTemplateVar ( 'totalamount', $totalamout );
		$this->AddTemplateVar ( 'totalsetup', _money_format ( $fmt, $totalSetup ) );
		$this->AddTemplateVar ( 'totalduenow', _money_format ( $fmt, $totalduenow ) );
		$companyinfo = GetCompanyInfoById ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['COMPANYID'] [0] ['VALUE'] );
		$this->AddTemplateVar ( 'companyinfo', $companyinfo );
		//$this->AddTemplateVar('showlanguage', '1');
		$this->AddTemplateVar ( 'inputs', $inputs );
		$createusernamexml = '<nixbill>
    <command>CreateUsername</command> 
</nixbill>';
		
		$createusername = $this->API ( $createusernamexml );
		$username = $createusername ['NIXBILL'] [0] ['RESULT'] [0] ['USERNAME'] [0] ['VALUE'];
		$password = $createusername ['NIXBILL'] [0] ['RESULT'] [0] ['PASSWORD'] [0] ['VALUE'];
		$this->AddTemplateVar ( 'username', $username );
		$this->AddTemplateVar ( 'password', $password );
		if (empty ( $this->ClientId )) {
			$this->Display ( PAYMENTINFORMATION );
		} else {
			$this->Display ( PAYMENTINFORMATIONCURRENTCLIENT );
		}
	}
	public function ViewCart() {
		$this->AddTemplateVar ( 'showleftbar', true );
		if (!$_GET ['ajax']) {
			$this->Redirect ();
		}
		//$this->AddItemToCart ();
		$sessionid = $this->GetSessionId ();
		$total = array ();
		/*echo '<pre>';
		print_r($_POST);
		exit;*/
		/**
		 * Query the API to get the cart contents
		 */
		$getcartxml = "<nixbill>
		<command>GetCart</command>
		<sessionid>" . $sessionid . "</sessionid>
		</nixbill>";
		$cart = $this->API ( $getcartxml );
		$result = $this->productarray;
		
		$this->AddTemplateVar ( 'sessionid', $sessionid );
		$this->AddTemplateVar ( 'title', $result ['NIXBILL'] [0] ['RESULT'] [0] ['TITLE'] [0] ['VALUE'] );
		setlocale ( LC_MONETARY, CleanInput ( $_REQUEST ['mon'], 'text' ) );
		$fmt = CleanInput ( $_REQUEST ['fmt'], 10 );
		if (isset ( $_POST ['checkcouponcode'] )) {
			$checkcoupon = '<nixbill>
    <command>CheckCouponCode</command> 
    <productid>' . CleanInput ( $_POST ['productid'], 'numeric' ) . '</productid>
    <couponcode>' . CleanInput ( $_POST ['couponcode'], 'text' ) . '</couponcode>
</nixbill>';
			$couponresult = $this->API ( $checkcoupon );
			if (strlen ( $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONTYPE'] [0] ['VALUE'] ) == 1) {
				$couponaccepted = true;
				$coupontype = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONTYPE'] [0] ['VALUE'];
				$couponamount = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONAMOUNT'] [0] ['VALUE'];
				$couponcycles = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONCYCLES'] [0] ['VALUE'];
				$this->AddTemplateVar ( 'checkedcode', CleanInput ( $_POST ['couponcode'], 'text' ) );
			} else {
				$this->AddTemplateVar ( 'invalidcoupon', '1' );
			}
		
		}
		/**
		 * starting here we need to loop this section.
		 * this will list all items in the cart seperatly
		 */
		$productcount = count ( $cart ['NIXBILL'] [0] ['RESULT'] [0] ['ITEMS'] [0] ['ITEM'] );
		
		for($ci = 0; $ci < $productcount; $ci ++) {
			$item = $cart ['NIXBILL'] [0] ['RESULT'] [0] ['ITEMS'] [0] ['ITEM'] [$ci];
			unset ( $productkey );
			
			for($pk = 0; $pk < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] ); $pk ++) {
				if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$pk] ['ID'] [0] ['VALUE'] == $item ['PRIMARY'] [0] ['PRODUCTID'] [0] ['VALUE']) {
					$productkey = $pk;
				}
				//	echo $item ['PRIMARY'] [0] ['PRODUCTID'] [0] ['VALUE'].'<br>';
			//	echo $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$pk] ['ID'] [0] ['VALUE'].'<hr>';
			}
			for($ck = 0; $ck < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] ); $ck ++) {
				if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$ck] ['ID'] [0] ['VALUE'] == $item ['PRIMARY'] [0] ['CYCLEID'] [0] ['VALUE']) {
					$cyclekey = $ck;
				}
			}
			//if(!$productkey) exit;
			$product ['cartid'] = $item ['PRIMARY'] [0] ['ID'] [0] ['VALUE'];
			$product ['quantity'] = $item ['PRIMARY'] [0] ['QUANTITY'] [0] ['VALUE'];
			$product ['image'] = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['IMAGE'] [0] ['VALUE'];
			$product ['id'] = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ID'] [0] ['VALUE'];
			$product ['name'] = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['NAME'] [0] ['VALUE'];
			$product ['cycle'] = GetCycleName ( $item ['PRIMARY'] [0] ['CYCLEID'] [0] ['VALUE'] );
			$product ['price'] = _money_format ( $fmt, ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$cyclekey] ['PRICE'] [0] ['VALUE'] * $product ['quantity']) );
			$product ['setup'] = _money_format ( $fmt, $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$cyclekey] ['SETUP'] [0] ['VALUE'] );
			
			$tcycle = $item ['PRIMARY'] [0] ['CYCLEID'] [0] ['VALUE'];
			$total [$tcycle] = $total [$tcycle] + ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$cyclekey] ['PRICE'] [0] ['VALUE'] * $product ['quantity']);
			if ($couponaccepted) {
				$this->AddTemplateVar ( 'subtotal', _money_format ( $fmt, $total [$tcycle] ) );
				$this->AddTemplateVar ( 'showcoupon', '1' );
				switch ($coupontype) {
					case 'p' :
						$_p = $total [$tcycle];
						$_c = $couponamount / 100;
						$_d = $_p * $_c;
						$coupondiscount = $_d;
						$total [$tcycle] = $total [$tcycle] - $coupondiscount;
						break;
					case 't' :
						$coupondiscount = $couponamount;
						$total [$tcycle] = $total [$tcycle] - $coupondiscount;
						break;
				}
				$this->AddTemplateVar ( 'coupondiscount', _money_format ( $fmt, $coupondiscount ) );
			}
			$totalSetup = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$cyclekey] ['SETUP'] [0] ['VALUE'];
			if (is_array ( $item ['EXTRAS'] [0] ['EXTRA'] )) {
				foreach ( $item ['EXTRAS'] [0] ['EXTRA'] as $ek => $extra ) {
					
					for($addk = 0; $addk < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] ); $addk ++) {
						if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$addk] ['ADDON'] [0] ['ID'] [0] ['VALUE'] == $extra ['PRODUCTID'] [0] ['VALUE']) {
							$groupkey = $addk;
						}
					}
					
					for($ck = 0; $ck < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] ); $ck ++) {
						if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$ck] ['ID'] [0] ['VALUE'] == $extra ['PRODUCTID'] [0] ['VALUE']) {
							$addonkey = $ck;
						}
					}
					for($ck = 0; $ck < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] ); $ck ++) {
						if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$ck] ['ID'] [0] ['VALUE'] == $extra ['CYCLEID'] [0] ['VALUE']) {
							$addoncyclekey = $ck;
						}
					}
					
					$addon [] = array ('id' => $extra ['PRODUCTID'] [0] ['VALUE'], 'cartid' => $extra ['ID'] [0] ['VALUE'], 'name' => $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['NAME'] [0] ['VALUE'], 'quantity' => $extra ['QUANTITY'] [0] ['VALUE'], 'cycle' => GetCycleName ( $extra ['CYCLEID'] [0] ['VALUE'] ), 'price' => _money_format ( $fmt, ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$addoncyclekey] ['PRICE'] [0] ['VALUE'] * $extra ['QUANTITY'] [0] ['VALUE']) ), 'setup' => _money_format ( $fmt, $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$addoncyclekey] ['SETUP'] [0] ['VALUE'] ) );
					$total [$extra ['CYCLEID'] [0] ['VALUE']] = $total [$extra ['CYCLEID'] [0] ['VALUE']] + ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$addoncyclekey] ['PRICE'] [0] ['VALUE'] * $extra ['QUANTITY'] [0] ['VALUE']);
					$totalSetup = $totalSetup + $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$addoncyclekey] ['SETUP'] [0] ['VALUE'];
				
				}
			
			}
			if ($item ['PRIMARY'] [0] ['CYCLEID'] [0] ['VALUE'] >= $this->Cfg ['freedomain'] && is_numeric ( $this->Cfg ['freedomain'] )) {
				$freedomain = true;
			}
			
			$tldarray = $result ['NIXBILL'] [0] ['RESULT'] [0] ['TLDS'] [0] ['TLD'];
			if (is_array ( $item ['EXTRAS'] [0] ['DOMAIN'] )) {
				foreach ( $item ['EXTRAS'] [0] ['DOMAIN'] as $dk => $domainarray ) {
					
					$domainSplit = SplitDomain ( $domainarray ['DOMAIN'] [0] ['VALUE'] );
					for($ftk = 0; $ftk < count ( $tldarray ); $ftk ++) {
						if ($tldarray [$ftk] ['EXT'] [0] ['VALUE'] == $domainSplit ['tld'])
							$tldkey = $ftk;
					}
					if (is_array ( $tldarray [$tldkey] ['CYCLES'] [0] ['CYCLE'] )) {
						foreach ( $tldarray [$tldkey] ['CYCLES'] [0] ['CYCLE'] as $tk => $tv ) {
							if ($tv ['ID'] [0] ['VALUE'] == $domainarray ['CYCLEID'] [0] ['VALUE']) {
								$tld = $tv;
							}
						}
					}
					if ($domainSplit ['tld'] == 'us') {
						$this->AddTemplateVar ( 'us_domain', '1' );
						$this->AddTemplateVar ( 'domainextra', '1' );
					}
					if ($domainSplit ['tld'] == 'co.uk') {
						$this->AddTemplateVar ( 'couk_domain', '1' );
						$this->AddTemplateVar ( 'domainextra', '1' );
					}
					if (is_numeric ( $domainarray ['CYCLEID'] [0] ['VALUE'] )) {
						if ($freedomain) {
							$tld ['PRICE'] [0] ['VALUE'] = 0;
							$freedomain = false;
						}
						
						$domain [] = array ('cartid' => $domainarray ['ID'] [0] ['VALUE'], 'id' => $tld ['ID'] [0] ['VALUE'], 'cycle' => GetCycleName ( $tld ['ID'] [0] ['VALUE'] ), 'price' => _money_format ( $fmt, $tld ['PRICE'] [0] ['VALUE'] ), 'setup' => _money_format ( $fmt, $tld ['SETUP'] [0] ['VALUE'] ), 'sld' => $domainSplit ['sld'], 'tld' => $domainSplit ['tld'] );
						$total [$tld ['ID'] [0] ['VALUE']] = $total [$tld ['ID'] [0] ['VALUE']] + $tld ['PRICE'] [0] ['VALUE'];
						$totalSetup = $totalSetup + $tld ['SETUP'] [0] ['VALUE'];
					}
				}
			
			}
			$out [] = array ('product' => $product, 'addon' => $addon, 'domain' => $domain, 'totalsetup' => $totalSetup, 'total' => $total );
			unset ( $domain );
			unset ( $addon );
			unset ( $product );
		
		}
		
		$this->AddTemplateVar ( 'productdata', $out );
		foreach ( $total as $tk => $tv ) {
			$totalamout [GetCycleName ( $tk )] = _money_format ( $fmt, $tv );
			$totalduenow = $totalduenow + $tv;
			$hasitem = true;
		}
		$totalduenow = $totalduenow + $totalSetup;
		$this->AddTemplateVar ( 'totalamount', $totalamout );
		$this->AddTemplateVar ( 'totalsetup', _money_format ( $fmt, $totalSetup ) );
		$this->AddTemplateVar ( 'totalduenow', _money_format ( $fmt, $totalduenow ) );
		$companyinfo = GetCompanyInfoById ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['COMPANYID'] [0] ['VALUE'] );
		$this->AddTemplateVar ( 'companyinfo', $companyinfo );
		$this->AddTemplateVar ( 'showlanguage', '1' );
		if ($productcount > 0) {
			$this->AddTemplateVar ( 'checkoutok', '1' );
		}
		if ($_GET ['ajax']) {
			$this->AddTemplateVar ( 'viewcartpopup', '1' );
			if($hasitem){
				$this->Display ( AJAXCART );
			}else{
				echo '<div align="center" style="padding:25px;"><strong>Your cart is currently empty</strong></div>';
			}
		} else {
			$this->Display ( VIEWCART );
		}
	}
}
$go = new products ( );
$go->Process ();
exit ();
?>