/**
 * $Id: editor_plugin_src.js 520 2008-01-07 16:30:32Z spocke $
 *
 * @author Moxiecode
 * @copyright Copyright  2004-2008, Moxiecode Systems AB, All rights reserved.
 */

(function() {
	tinymce.create('tinymce.plugins.nixbill', {
		init : function(ed, url) {
			var t = this;

			t.editor = ed;

			ed.addCommand('firstname', function() {
				var str = '[*FIRSTNAME*]';

				ed.execCommand('mceInsertContent', false, str);
			});

			ed.addButton('firstname', {
				title : 'First Name',
				cmd : 'firstname',
				image : url + '/img/example.gif'
			});
			
			ed.addCommand('lastname', function() {
				var str = '[*LASTNAME*]';

				ed.execCommand('mceInsertContent', false, str);
			});

			ed.addButton('lastname', {
				title : 'Last Name',
				cmd : 'lastname',
				image : url + '/img/example.gif'
			});
			
			ed.addCommand('username', function() {
				var str = '[*USERNAME*]';

				ed.execCommand('mceInsertContent', false, str);
			});

			ed.addButton('username', {
				title : 'Username',
				cmd : 'username',
				image : url + '/img/example.gif'
			});
			
			ed.addCommand('password', function() {
				var str = '[*PASSWORD*]';

				ed.execCommand('mceInsertContent', false, str);
			});

			ed.addButton('password', {
				title : 'Password',
				cmd : 'password',
				image : url + '/img/example.gif'
			});
			
			ed.addCommand('ipaddress', function() {
				var str = '[*IPADDRESS*]';

				ed.execCommand('mceInsertContent', false, str);
			});

			ed.addButton('ipaddress', {
				title : 'IP Address',
				cmd : 'ipaddress',
				image : url + '/img/example.gif'
			});
			
			ed.addCommand('cpanel', function() {
				var str = '[*CPANEL*]';

				ed.execCommand('mceInsertContent', false, str);
			});

			ed.addButton('cpanel', {
				title : 'cPanel Information',
				cmd : 'cpanel',
				image : url + '/img/example.gif'
			});
			
			ed.addCommand('plesk', function() {
				var str = '[*PLESK*]';

				ed.execCommand('mceInsertContent', false, str);
			});

			ed.addButton('plesk', {
				title : 'Plesk Information',
				cmd : 'plesk',
				image : url + '/img/example.gif'
			});
			
			ed.addCommand('ftp', function() {
				var str = '[*FTP*]';

				ed.execCommand('mceInsertContent', false, str);
			});

			ed.addButton('ftp', {
				title : 'FTP Information',
				cmd : 'ftp',
				image : url + '/img/example.gif'
			});
			
			ed.addCommand('nameservers', function() {
				var str = '[*NAMESERVERS*]';

				ed.execCommand('mceInsertContent', false, str);
			});

			ed.addButton('nameservers', {
				title : 'Name Servers',
				cmd : 'nameservers',
				image : url + '/img/example.gif'
			});
			
			/*ed.addCommand('mcenixvar', function() {
				var str = '$test';
username,password,ipaddress,cpanel,plesk,ftp,nameservers
				ed.execCommand('mceInsertContent', false, str);
			});

			ed.addButton('nixbill_vars', {
				title : 'example.desc',
				cmd : 'mcenixvar',
				image : url + '/img/example.gif'
			});*/

		},

		getInfo : function() {
			return {
				longname : 'Insert date/time',
				author : 'Moxiecode Systems AB',
				authorurl : 'http://tinymce.moxiecode.com',
				infourl : 'http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/insertdatetime',
				version : tinymce.majorVersion + "." + tinymce.minorVersion
			};
		},
	
		// Private methods

		_getDateTime : function(d, fmt) {
			var ed = this.editor;

			function addZeros(value, len) {
				value = "" + value;

				if (value.length < len) {
					for (var i=0; i<(len-value.length); i++)
						value = "0" + value;
				}

				return value;
			};

			fmt = fmt.replace("%D", "%m/%d/%y");
			fmt = fmt.replace("%r", "%I:%M:%S %p");
			fmt = fmt.replace("%Y", "" + d.getFullYear());
			fmt = fmt.replace("%y", "" + d.getYear());
			fmt = fmt.replace("%m", addZeros(d.getMonth()+1, 2));
			fmt = fmt.replace("%d", addZeros(d.getDate(), 2));
			fmt = fmt.replace("%H", "" + addZeros(d.getHours(), 2));
			fmt = fmt.replace("%M", "" + addZeros(d.getMinutes(), 2));
			fmt = fmt.replace("%S", "" + addZeros(d.getSeconds(), 2));
			fmt = fmt.replace("%I", "" + ((d.getHours() + 11) % 12 + 1));
			fmt = fmt.replace("%p", "" + (d.getHours() < 12 ? "AM" : "PM"));
			fmt = fmt.replace("%B", "" + ed.getLang("insertdatetime.months_long").split(',')[d.getMonth()]);
			fmt = fmt.replace("%b", "" + ed.getLang("insertdatetime.months_short").split(',')[d.getMonth()]);
			fmt = fmt.replace("%A", "" + ed.getLang("insertdatetime.day_long").split(',')[d.getDay()]);
			fmt = fmt.replace("%a", "" + ed.getLang("insertdatetime.day_short").split(',')[d.getDay()]);
			fmt = fmt.replace("%%", "%");

			return fmt;
		}
	});

	// Register plugin
	tinymce.PluginManager.add('nixbill', tinymce.plugins.nixbill);
})();