<?php

session_start ();

/**
 * This is a single page order form system. All actions are handled by this php file. There is some code duplication in this file
 * that will be removed in later releases. This page can be saved as anything.php and run the order form. Just change the 
 * order form id to match that you want used with this file. 
 */

/**
 * Orderform config section
 * Set the order form ID 
 */
if (isset ( $_GET ['orderformid'] )) {
	$_SESSION ['orderformid'] = ( int ) $_GET ['orderformid'];
	define ( 'ORDERFORMID', ( int ) $_GET ['orderformid'] );
} elseif (isset ( $_SESSION ['orderformid'] )) {
	define ( 'ORDERFORMID', ( int ) $_SESSION ['orderformid'] );
} else {
	define ( 'ORDERFORMID', 1 );
}


/**
 * Order form smarty templates
 * Set the file names of the templates here
 *
 * PAGE1PRODUCTDISPLAY 
 * main product information block on the index page
 * 
 */
define ( 'PAGE1PRODUCTDISPLAY', 'orderform.tpl' );

/**
 * PAGE1DOMAINDISPLAY 
 * domain section on the index page
 * 
 */
define ( 'PAGE1DOMAINDISPLAY', 'domainblock.tpl' );

/**
 * PAGE1MAINTEMPLATE 
 * Main index page (wrapper to the orderform and domain block)
 * 
 */
define ( 'PAGE1MAINTEMPLATE', 'index.tpl' );

/**
 * PAYMENTINFORMATION 
 * Second page, payment information template
 * 
 */
define ( 'PAYMENTINFORMATION', 'paymentinformation.tpl' );

/**
 * PAYMENTINFORMATIONCURRENTCLIENT
 * Second page, payment information template, current client order form (must be logged in to see this one)
 * 
 */
define ( 'PAYMENTINFORMATIONCURRENTCLIENT', 'paymentinformationcurrentclient.tpl' );

/**
 * ORDERCOMPLETED 
 * Last page, completed order processed with a credit card
 * 
 */
define ( 'ORDERCOMPLETED', 'order_completed_cc.tpl' );

/**
 * ORDERCOMPLETEDPAYPAL
 * Last page, completed order paypal
 * 
 */
define ( 'ORDERCOMPLETEDPAYPAL', 'paypal.tpl' );

/**
 * ORDERCOMPLETEDFREE 
 * Last page, completed order for a free product
 * 
 */
define ( 'ORDERCOMPLETEDFREE', 'processorder_free.tpl' );
/**
 * ORDERFAILED
 * Last page, order failed
 *
 */
define ( 'ORDERFAILED', 'order_failed_cc.tpl' );

define ( 'PAGE1', 'order_page1.tpl' );
define ( 'PAGE2', 'order_page2.tpl' );
define ( 'PAGE3', 'order_page3.tpl' );

define ( 'ACTION', basename ( $_SERVER ['PHP_SELF'] ) );
/**
 * This xml is an example of how the order form can be set to run off a static xml file. This would not 
 * require the system to query the API each time it needed to know wha the product information is.
 * If your order form changes frequently it would be best to leave it as is.
 * This xml was generated by using the "Test API" under the system menu from NixBill admin panel
 * To produce this xml run this code in the test api
<nixbill>
    <command>GetFullOrderForm</command> 
    <orderformid>' . ORDERFORMID . '</orderformid>
</nixbill>
 * 
 * where the ORDERFORMID is the id of the orderform you will be using
 */

require_once '../include/libs/order.php';
require_once path ( 'include/libs/formatproducts_v2.php' );
/**
 * Free domain. set this to the cycle id of the main product.
 * if the cycle of themain product is grater than or equal to this number, you will give away 1 free domain 
 * cycle id 6 = year
 */
$cfg ['freedomain'] = false;
/**
 * tmp dir for smarty templates
 * this is only needed if you use more than one order form with different templates
 * Leave it blank to use the default tmp directory
 *
 */

if(!is_dir($cfg['tempDir'].'/of')){
	mkdir($cfg['tempDir'].'/of');	
}
define ( 'TMPDIR', $cfg['tempDir'].'/of' );

class products extends order {
	private $errors = array ();
	private $paymenterrors = array ();
	
	public function __construct() {
		parent::__construct ( TMPDIR );
		$productlist = '<nixbill>
    <command>GetFullOrderForm</command> 
    <orderformid>' . ORDERFORMID . '</orderformid>
</nixbill>';
		$this->Translation ();
		$this->productarray = $this->API ( $productlist );
		
	}
	
	public function Process() {
		/*echo '<pre>';
		print_r($this->productarray);
		exit;*/
		$this->AddTemplateVar ( 'pagetitle', $this->productarray['NIXBILL'][0]['RESULT'][0]['TITLE'][0]['VALUE'] );
		$this->AddTemplateVar ( 'companyname', $this->productarray['NIXBILL'][0]['RESULT'][0]['COMPANYNAME'][0]['VALUE'] );
		$this->AddTemplateVar ( 'acceptpp', $this->productarray['NIXBILL'][0]['RESULT'][0]['ACCEPTPP'][0]['VALUE'] );
		$this->AddTemplateVar ( 'acceptcc', $this->productarray['NIXBILL'][0]['RESULT'][0]['ACCEPTCC'][0]['VALUE'] );
		if($this->productarray['NIXBILL'][0]['RESULT'][0]['ACCEPTCC'][0]['VALUE'] ==1){
			$this->AddTemplateVar ( 'cc_checked', 'checked="checked"');
		}elseif($this->productarray['NIXBILL'][0]['RESULT'][0]['ACCEPTCC'][0]['VALUE'] ==0){
			$this->AddTemplateVar ( 'pp_checked', 'checked="checked"');
		}
		/**
		 * check if the request is for a special function
		 */
		if (isset ( $_REQUEST ['checkcouponcode'] )) {
			$this->CheckCouponCode ();
			return false;
		}
		
		/**
		 * Check order status and goto page
		 */
		if (isset ( $_REQUEST ['domaintype'] ) && !isset ( $_POST ['paymenttype'] )) {
			switch ($_REQUEST ['domaintype']) {
				case 'new' :
					$sld = CleanInput ( $_REQUEST ['sld'], 'text' );
					$tld = CleanInput ( $_REQUEST ['tld'], 'text' );
					$d = $sld.'.'.$tld;
					$domainstatus = CheckDomain ( CleanInput ( $_REQUEST ['sld'], 'text' ), CleanInput ( $_REQUEST ['tld'], 'text' ) );
					//if (preg_match ( '/^([a-zA-Z0-9]([a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])?\.)+[a-zA-Z]{2,6}$/', $domainstatus )) {
					

					if ($domainstatus) {
						if (! $this->ValidateDomain($domainstatus)) {
							$this->AddTemplateVar ( 'domain_not_formatted', 1 );
							$this->Page1 ();
						} else {
							/**
							 * domain is available
							 */
							$this->AddTemplateVar ( 'new_domain', 1 );
							if (CleanInput ( $_REQUEST ['tld'], 'text' ) == 'us') {
								$this->AddTemplateVar ( 'us_domain', '1' );
							}
							$this->Page2 ( $domainstatus );
						}
					} elseif($this->CheckOtherDomains($sld, $tld, $this->productarray['NIXBILL'][0]['RESULT'][0]['TLDS'][0]['TLD']) && $this->ValidateDomain($d)){
						
						$this->Page1 ();
					}else{
						$this->AddTemplateVar ( 'domain_not_available', 1 );
						$this->Page1 ();
					}
					//} else {
					//$this->AddTemplateVar ( 'domain_not_formatted', 1 );
					//$this->Page1 ();
					//}
					

					break;
				case 'owned' :
					/**
					 * owned domain, check the domain format
					 */
					$domain = CleanInput ( $_REQUEST ['sldtld'], 'text' );
					if ($this->ValidateDomain($domain)) {
						$this->Page2 ( $domain );
					
					}else{
						$this->AddTemplateVar ( 'domain_not_formatted', 1 );
						$this->Page1 ();
					}
					break;
				case 'na' :
					/**
					 * domain not required
					 */
					$this->Page2 ( false );
					break;
			}
		} elseif (isset ( $_POST ['paymenttype'] ) && !empty($_POST['productid'])) {
			/**
			 * order has been submitted
			 */
			$this->Page3 ();
		} elseif (isset($_REQUEST['productid'])) {
			/**
			 * new order started display page 1
			 */
			$this->Page1 ();
		}else{
			/**
			 * Show the product list
			 */
			$this->ProductList ();
		}
	}
	private function ValidateDomain($domain){
		if (preg_match ( '/^([a-zA-Z0-9]([a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])?\.)+[a-zA-Z]{2,6}$/', $domain )) {
			return true;
		}
		return false;
	}
	private function CheckCouponCode() {
		
		$checkcoupon = '<nixbill>
    <command>CheckCouponCode</command> 
    <productid>' . CleanInput ( $_REQUEST ['productid'], 'numeric' ) . '</productid>
    <couponcode>' . CleanInput ( $_REQUEST ['couponcode'], 'text' ) . '</couponcode>
    <cycleid>' . CleanInput ( $_REQUEST ['cycleid'], 'numeric' ) . '</cycleid>
</nixbill>';
		$couponresult = $this->API ( $checkcoupon );
		if (strlen ( $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONTYPE'] [0] ['VALUE'] ) == 1) {
			$couponaccepted = true;
			$coupontype = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONTYPE'] [0] ['VALUE'];
			$couponamount = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONAMOUNT'] [0] ['VALUE'];
			$couponcycles = $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONCYCLES'] [0] ['VALUE'];
			//$this->AddTemplateVar ( 'checkedcode', CleanInput ( $_REQUEST ['couponcode'], 'text' ) );
			if ($coupontype == 't') {
				echo '$' . $couponamount;
			} else {
				echo $couponamount . '%';
			}
		} else {
			//$this->AddTemplateVar ( 'invalidcoupon', '1' );
			//	$smarty->assign('couponreason', $couponresult['NIXBILL'][0]['RESULT'][0]['COUPONREASON'][0]['VALUE']);
			if ($couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONREASON'] [0] ['VALUE']) {
				$output = str_replace ( '<br /> <a href="index.php">Click here to go back</a>', '', $couponresult ['NIXBILL'] [0] ['RESULT'] [0] ['COUPONREASON'] [0] ['VALUE'] );
				echo $output;
			} else {
				echo 0;
			}
		}
		return FALSE;
	
	}
	private function DetectBrowser() {
		if (preg_match ( '/Chrome/', $_SERVER ['HTTP_USER_AGENT'] )) {
			$this->AddTemplateVar ( 'browser', 'chrome' );
		} elseif (preg_match ( '/Firefox/', $_SERVER ['HTTP_USER_AGENT'] )) {
			$this->AddTemplateVar ( 'browser', 'firefox' );
		} elseif (preg_match ( '/MSIE/', $_SERVER ['HTTP_USER_AGENT'] )) {
			$this->AddTemplateVar ( 'browser', 'ie' );
		} else {
			$this->AddTemplateVar ( 'browser', 'ie' );
		}
		return false;
	}
	private function ProductList(){
		$p = new formatproducts ( );
		$products = $p->Process ( $this->productarray, false, false);
		$this->AddTemplateVar ( 'products', $products );
		$this->Display ( 'order_productlist.tpl' );
		return false;
	}
	private function Page1() {
		
		/**
		 * Set referrer
		 */
		if (! $_COOKIE ['referer']) {
			$referer = $_SERVER ['HTTP_REFERER'];
		} else {
			$referer = CleanInput ( $_COOKIE ['referer'], 'text' );
		}
		$this->AddTemplateVar ( 'referer', $referer );
		$others = $this->GetOtherDomains();
		if(count($others)>0){
			$this->AddTemplateVar ( 'otherdomains', 1 );
			$this->AddTemplateVar ( 'otherdomainnames', $others );
		}
		$result = $this->productarray;
		for($t = 0; $t < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['TLDS'] [0] ['TLD'] ); $t ++) {
			$tldvalues [] = $result ['NIXBILL'] [0] ['RESULT'] [0] ['TLDS'] [0] ['TLD'] [$t] ['EXT'] [0] ['VALUE'];
		}
		
		$this->AddTemplateVar ( 'tldoptions', $tldvalues );
		$this->AddTemplateVar ( 'tldselected', CleanInput ( $_REQUEST ['tld'], 'text' ) );
		
		
		
		
		//$productcycle = ( int ) $_REQUEST ['cycleid'];
		if (! empty ( $_REQUEST ['productid'] )) {
			$productid = ( int ) $_REQUEST ['productid'];
		} else {
			$productid = $this->productarray ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [0] ['ID'] [0] ['VALUE'];
		}
		
		if ($this->productarray ['NIXBILL'] [0] ['RESULT'] [0] ['ALLOWCOUPONS'] [0] ['VALUE'] == 1) {
			$this->AddTemplateVar ( 'allowcoupons', '1' );
		}
		$p = new formatproducts ( );
		//$products = $p->Process ( $this->productarray, $productid, $productcycle);
		$products = $p->GetOneProduct($this->productarray, $productid);
		if (count ( $products ) == 1)
			$this->AddTemplateVar ( 'one', '1' );
		
		$productlist = $p->GetProductList();
		
		$this->AddTemplateVar ( 'jumpbox', $productlist );
		$this->AddTemplateVar ( 'products', $products );
		$this->AddTemplateVar ( 'productinfo', $p->GetProductInfo () );
		$this->AddTemplateVar ( 'domainrequired', $p->GetDomainRequired () );
		$this->AddTemplateVar ( 'productcycle', $p->GetCycles () );
		$this->AddTemplateVar ( 'productaddons', $p->GetAddons () );
		$this->AddTemplateVar ( 'productaddongroups', $p->GetAddonGroups () );
		$this->Display ( PAGE1 );
	}
	private function Page2($domain) {

		$errors = $this->GetErrors ();
		if ($errors ['NIXBILL'] [0] ['RESULT'] [0] ['ERRORS'] [0] ['ATTRIBUTES'] ['COUNT'] > 0) {
			$this->AddTemplateVar ( 'haserrors', 1 );
			foreach ( $errors ['NIXBILL'] [0] ['RESULT'] [0] ['ERRORS'] [0] ['ERROR'] as $error ) {
				$e [] = $error ['VALUE'];
			}
			$this->AddTemplateVar ( 'errors', $e );
			$this->AddTemplateVar ( 'fname', CleanInput ( $_POST ['fname'], 'text' ) );
			$this->AddTemplateVar ( 'lname', CleanInput ( $_POST ['lname'], 'text' ) );
			$this->AddTemplateVar ( 'email', CleanInput ( $_POST ['email1'], 'text' ) );
			$this->AddTemplateVar ( 'email2', CleanInput ( $_POST ['email2'], 'text' ) );
			$this->AddTemplateVar ( 'address', CleanInput ( $_POST ['address1'], 'text' ) );
			$this->AddTemplateVar ( 'address2', CleanInput ( $_POST ['address2'], 'text' ) );
			$this->AddTemplateVar ( 'city', CleanInput ( $_POST ['city'], 'text' ) );
			$this->AddTemplateVar ( 'zipcode', CleanInput ( $_POST ['zipcode'], 'text' ) );
			$this->AddTemplateVar ( 'username', CleanInput ( $_POST ['username'], 'text' ) );
			$this->AddTemplateVar ( 'password', CleanInput ( $_POST ['password'], 'text' ) );
			$this->AddTemplateVar ( 'password2', CleanInput ( $_POST ['password2'], 'text' ) );
			$this->AddTemplateVar ( 'phone', CleanInput ( $_POST ['phone1'], 'text' ) );
			$this->AddTemplateVar ( 'phone2', CleanInput ( $_POST ['phone2'], 'text' ) );
			$this->AddTemplateVar ( 'firstnameoncard', CleanInput ( $_POST ['firstnameoncard'], 'text' ) );
			$this->AddTemplateVar ( 'lastnameoncard', CleanInput ( $_POST ['lastnameoncard'], 'text' ) );
			$domaininformation = $this->GetDomainInformation ();
			if ($domaininformation ['type'] == 'new') {
				$this->AddTemplateVar ( 'new_domain', 1 );
			}
		}
		$productcycle = ( int ) $_REQUEST ['cycleid'];
		$productid = ( int ) $_REQUEST ['productid'];
		if ($this->productarray ['NIXBILL'] [0] ['RESULT'] [0] ['ALLOWCOUPONS'] [0] ['VALUE'] == 1) {
			$this->AddTemplateVar ( 'allowcoupons', '1' );
		}
		$p = new formatproducts ( );
		$products = $p->Process ( $this->productarray, $productid, $productcycle,1 );
		if (count ( $products ) == 1)
			$this->AddTemplateVar ( 'one', '1' );
		$this->AddTemplateVar ( 'products', $products );
		$this->AddTemplateVar ( 'productinfo', $p->GetProductInfo () );
		$this->AddTemplateVar ( 'domainrequired', $p->GetDomainRequired () );
		$this->AddTemplateVar ( 'productcycle', $p->GetCycles () );
		$this->AddTemplateVar ( 'productaddons', $p->GetAddons () );
		$this->AddTemplateVar ( 'productaddongroups', $p->GetAddonGroups () );
		
		if (! empty ( $this->ClientId )) {
			$billingaccounts = db::GetAllRows ( "SELECT * FROM billingaccounts WHERE clientid = '" . $this->ClientId . "'" );
			$this->AddTemplateVar ( 'billingaccounts', $billingaccounts );
			$this->AddTemplateVar ( 'currentclient', '1' );
		}
		if($_REQUEST ['domaintype'] == 'new'){
		$tldarray = $this->productarray ['NIXBILL'] [0] ['RESULT'] [0] ['TLDS'] [0] ['TLD'];
		$domainSplit = SplitDomain ( $domain );
		for($ftk = 0; $ftk < count ( $tldarray ); $ftk ++) {
			if ($tldarray [$ftk] ['EXT'] [0] ['VALUE'] == $domainSplit ['tld']){
				$tldkey = $ftk;
			}
		}
		$cycle=6;
		//if($productcycle>5)$cycle = $productcycle;
		if (is_array ( $tldarray [$tldkey] ['CYCLES'] [0] ['CYCLE'] )) {
			foreach ( $tldarray [$tldkey] ['CYCLES'] [0] ['CYCLE'] as $tv ) {
				if ($tv ['ID'] [0] ['VALUE'] == $cycle) {
					$tld = $tv;
				}
			}
		}
		$this->AddTemplateVar('domainprice',$tld ['PRICE'] [0] ['VALUE']);
		}
		$countries = countries ();
		$states = states ();
		$this->AddTemplateVar ( 'countries_selected', $countries ['selected'] );
		$this->AddTemplateVar ( 'countries_display', $countries ['name'] );
		$this->AddTemplateVar ( 'countries_value', $countries ['code'] );
		$this->AddTemplateVar ( 'states_display', $states ['name'] );
		$this->AddTemplateVar ( 'states_value', $states ['code'] );
		$this->AddTemplateVar ( 'domain', $domain );
		$referer = CleanInput ( $_POST ['referer'], 'text' );
		$this->AddTemplateVar ( 'referer', $referer );
		if(!empty($this->ClientId)){
			$billingaccounts = db::GetAllRows("SELECT * FROM billingaccounts WHERE clientid = '".$this->ClientId."'");
			$this->AddTemplateVar('billingaccounts', $billingaccounts);
			$this->AddTemplateVar('currentclient', 1);
		}
		$this->Display ( PAGE2 );
	}
	private function Page3() {
		$domain = CleanInput ( $_POST ['domain'], 'text' );
		$createusernamexml = '<nixbill>
    <command>CreateUsername</command> 
    
    <domain>' . CleanInput ( $_POST ['domain'], 'text' ) . '</domain>
</nixbill>';
		
		$createusername = $this->API ( $createusernamexml );
		$username = $createusername ['NIXBILL'] [0] ['RESULT'] [0] ['USERNAME'] [0] ['VALUE'];
		$password = $createusername ['NIXBILL'] [0] ['RESULT'] [0] ['PASSWORD'] [0] ['VALUE'];
		$nameoncard = CleanInput ( $_POST ['nameoncard'], 'text' );
		$n = explode ( ' ', $nameoncard );
		$c = count ( $n );
		$fname = '';
		for($z = 0; $z < $c; $z ++) {
			if ($z < ($c - 1)) {
				$fname .= $n [$z];
			} else {
				$lname = $n [$z];
			}
		}
		if (preg_match ( '/^baid/', $_POST ['paymenttype'] ) && ! empty ( $this->ClientId )) {
			$baid = explode ( '_', $_POST ['paymenttype'] );
			$billingaccountid = ( int ) $baid [1];
			$paymenttype = 1;
			
		} else {
			$paymenttype = ( int ) $_POST ['paymenttype'];
			$newbillingaccount = 1;
		}
		$requirements = '<nixbill>
		<command>OrderRequirements</command>
		<clientdetails>
		<clientid>' . $this->ClientId . '</clientid>
		<newbillingaccount>' . $newbillingaccount. '</newbillingaccount>
		<firstname>' . CleanInput ( $_POST ['fname'], 'text' ) . '</firstname>
		<lastname>' . CleanInput ( $_POST ['lname'], 'text' ) . '</lastname>
		<username>' . $username . '</username>
		<email1>' . CleanInput ( $_POST ['email1'], 'text' ) . '</email1>
		<email2>' . CleanInput ( $_POST ['email2'], 'text' ) . '</email2>
		<address1>' . CleanInput ( $_POST ['address1'], 'text' ) . '</address1>
		<address2>' . CleanInput ( $_POST ['address2'], 'text' ) . '</address2>
		<city>' . CleanInput ( $_POST ['city'], 'text' ) . '</city>
		<state>' . CleanInput ( $_POST ['state'], 'text' ) . '</state>
		<zipcode>' . CleanInput ( $_POST ['zipcode'], 'text' ) . '</zipcode>
		<country>' . CleanInput ( $_POST ['country'], 'text' ) . '</country>
		<phone1>' . CleanInput ( $_POST ['phone1'], 'numeric' ) . '</phone1>
		<phone2>' . CleanInput ( $_POST ['phone2'], 'numeric' ) . '</phone2>
		<company>' . CleanInput ( $_POST ['company'], 'text' ) . '</company>
		<paymenttype>' . CleanInput ( $_POST ['paymenttype'], 'numeric' ) . '</paymenttype>
		<cardnumber>' . CleanInput ( $_POST ['cardnumber'], 'numeric' ) . '</cardnumber>
		<firstnameoncard>' . $fname . '</firstnameoncard>
		<lastnameoncard>' . $lname . '</lastnameoncard>
		<carddate>' . CleanInput ( $_POST ['ExpMonth'], 'numeric' ) . substr ( CleanInput ( $_POST ['ExpYear'], 'numeric' ), 2, 2 ) . '</carddate>
		<cardtype>' . CleanInput ( $_POST ['cardtype'], 'text' ) . '</cardtype> 
		<cardcvv2>' . CleanInput ( $_POST ['cvv2'], 'numeric' ) . '</cardcvv2>
		<language>' . CleanInput ( $_POST ['language'], 'text' ) . '</language>
		<companyid>' . CleanInput ( $_POST [''], 'numeric' ) . '</companyid>
		<password>' . $password . '</password>
		<password2>' . $password . '</password2>
		<tos>' . CleanInput ( $_POST ['tos'], 'text' ) . '</tos>
		</clientdetails>
	</nixbill>';
		
		$orderreq = $this->API ( $requirements );
		if ($orderreq ['NIXBILL'] [0] ['RESULT'] [0] ['ERRORS'] [0] ['ATTRIBUTES'] ['COUNT'] > 0) {
			$this->SetErrors ( $orderreq );
			$domaininfo ['type'] = CleanInput ( $_REQUEST ['domaintype'], 'text' );
			$this->SetDomainInformation ( $domaininfo );
			$this->Page2 ( CleanInput ( $_POST ['domain'], 'text' ) );
			return false;
		}
		
		$result = $this->productarray;
		
		$orderformxml = '<nixbill>
	<command>GetOrderForm</command> 
	<orderformid>' . ORDERFORMID . '</orderformid>
	</nixbill>';
		//$orderformdetails = $this->API ( $orderformxml );
		if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['FRAUDID'] [0] ['VALUE'] > 0 && empty ( $this->ClientId )) {
			$emaildomain = explode ( '@', CleanInput ( $_POST ['email1'], 'text' ) );
			$usefraud = '<usefraud>1</usefraud>';
			
			$processfraud = '<nixbill>
				<command>ProcessFraud</command> 
				
				<moduleid>' . $result ['NIXBILL'] [0] ['RESULT'] [0] ['FRAUDID'] [0] ['VALUE'] . '</moduleid>
				<clientdetails>
					<firstname>' . CleanInput ( $_POST ['fname'], 'text' ) . '</firstname>
					<lastname>' . CleanInput ( $_POST ['lname'], 'text' ) . '</lastname>
					<city>' . CleanInput ( $_POST ['city'], 'text' ) . '</city>
					<zipcode>' . CleanInput ( $_POST ['zipcode'], 'text' ) . '</zipcode>
					<region>' . CleanInput ( $_POST ['state'], 'text' ) . '</region>
					<ip>' . $_SERVER ['REMOTE_ADDR'] . '</ip>
					<country>' . CleanInput ( $_POST ['country'], 'text' ) . '</country>
					<phone>' . CleanInput ( $_POST ['phone1'], 'numeric' ) . '</phone>
					<domain>' . $emaildomain [1] . '</domain>
					<email>' . CleanInput ( $_POST ['email1'], 'text' ) . '</email>
					<forwardip>' . $_SERVER ['HTTP_X_FORWARDED'] . '</forwardip>
					<username>' . md5 ( $username ) . '</username>
					<password>' . md5 ( $password ) . '</password>
					
				</clientdetails>
				</nixbill>';
			$fraudresult = $this->API ( $processfraud );
			
			$fraudresultxml = '<fraudresults>'; /// need to put error checking here incase there is a failure on the fraud module.
			if (is_array ( $fraudresult ['NIXBILL'] [0] ['RESULT'] [0] ['FRAUDRETURN'] [0] )) {
				foreach ( $fraudresult ['NIXBILL'] [0] ['RESULT'] [0] ['FRAUDRETURN'] [0] as $fk => $fv ) {
					$fraudresultxml .= '<' . $fk . '>' . $fv [0] ['VALUE'] . '</' . $fk . '>
		';
				}
			}
			$fraudresultxml .= '</fraudresults>';
		}
		
		$processorder = '<nixbill> 
	<command>CreateOrder</command> 
	<paymenttype>' . $paymenttype . '</paymenttype>
	<paymentfunction>sale</paymentfunction>
	<orderform>' . ORDERFORMID . '</orderform>
	' . $usefraud . '
	<clientdetails>';
		if ($this->ClientId) {
			$processorder .= '
			<clientid>' . $this->ClientId . '</clientid>
			<username>' . $this->ClientDetails ['email'] . '</username>
			<password>' . $this->ClientDetails ['password'] . '</password>';
		} else {
			$processorder .= '
			<username>' . $username . '</username>
			<password>' . $password . '</password>
			';
		}
		$processorder .= '<billingaccountid>' . $billingaccountid . '</billingaccountid>
		<firstname>' . CleanInput ( $_POST ['fname'], 'text' ) . '</firstname>
		<lastname>' . CleanInput ( $_POST ['lname'], 'text' ) . '</lastname>
		
		<email1>' . CleanInput ( $_POST ['email1'], 'text' ) . '</email1>
		<email2>' . CleanInput ( $_POST ['email2'], 'text' ) . '</email2>
		<address1>' . CleanInput ( $_POST ['address1'], 'text' ) . '</address1>
		<address2>' . CleanInput ( $_POST ['address2'], 'text' ) . '</address2>
		<city>' . CleanInput ( $_POST ['city'], 'text' ) . '</city>
		<state>' . CleanInput ( $_POST ['state'], 'text' ) . '</state>
		<zipcode>' . CleanInput ( $_POST ['zipcode'], 'text' ) . '</zipcode>
		<country>' . CleanInput ( $_POST ['country'], 'text' ) . '</country>
		<phone1>' . CleanInput ( $_POST ['phone1'], 'numeric' ) . '</phone1>
		<phone2>' . CleanInput ( $_POST ['phone2'], 'numeric' ) . '</phone2>
		<company>' . CleanInput ( $_POST ['company'], 'text' ) . '</company>
		<cardnumber>' . CleanInput ( $_POST ['cardnumber'], 'numeric' ) . '</cardnumber>
		<firstnameoncard>' . $fname . '</firstnameoncard>
		<lastnameoncard>' . $lname . '</lastnameoncard>
		<carddate>' . CleanInput ( $_POST ['ExpMonth'], 'numeric' ) . substr ( CleanInput ( $_POST ['ExpYear'], 'numeric' ), 2, 2 ) . '</carddate>
		<cardtype>' . CleanInput ( $_POST [''], 'text' ) . '</cardtype> 
		<cardcvv2>' . CleanInput ( $_POST ['cvv2'], 'numeric' ) . '</cardcvv2>
		<language>' . CleanInput ( $_POST ['language'], 'text' ) . '</language>
		<companyid>' . CleanInput ( $_POST [''], 'numeric' ) . '</companyid>
		
		<signupip>' . $_SERVER ['REMOTE_ADDR'] . '</signupip>
		<referrer><![CDATA[' . CleanInput ( $_POST ['referer'], 'text' ) . ']]></referrer>
		<affiliatetracker></affiliatetracker>
<affiliateid></affiliateid>
		<status>0</status>
	</clientdetails>';
		
		if(empty($this->ClientId)){
			$processorder .= '	<domaindetails>
		<firstname>' . CleanInput ( $_POST ['fname'], 'text' ) . '</firstname>
		<lastname>' . CleanInput ( $_POST ['lname'], 'text' ) . '</lastname>
		<email1>' . CleanInput ( $_POST ['email1'], 'text' ). '</email1>
		<address1>' . CleanInput ( $_POST ['address1'], 'text' ) . '</address1>
		<address2>' . CleanInput ( $_POST ['address2'], 'text' ) . '</address2>
		<city>' . CleanInput ( $_POST ['city'], 'text' ) . '</city>
		<state>' . CleanInput ( $_POST ['state'], 'text' ) . '</state>
		<zipcode>' . CleanInput ( $_POST ['zipcode'], 'text' ) . '</zipcode>
		<country>' . CleanInput ( $_POST ['country'], 'text' ) . '</country>
		<phone1>' . CleanInput ( $_POST ['phone1'], 'numeric' ) . '</phone1>
		<company>' . CleanInput ( $_POST ['company'], 'text' ) . '</company>';
		}else{
			$processorder .= '	<domaindetails>
		<firstname>' . $this->ClientDetails ['fname'] . '</firstname>
		<lastname>' . $this->ClientDetails ['lname'] . '</lastname>
		<email1>' . $this->ClientDetails ['email'] . '</email1>
		<address1>' . $this->ClientDetails ['address1'] . '</address1>
		<address2>' . $this->ClientDetails ['address2'] . '</address2>
		<city>' . $this->ClientDetails ['city'] . '</city>
		<state>' . $this->ClientDetails ['state'] . '</state>
		<zipcode>' . $this->ClientDetails ['zip'] . '</zipcode>
		<country>' . $this->ClientDetails ['country']. '</country>
		<phone1>' . $this->ClientDetails ['phone'] . '</phone1>
		<company>' . $this->ClientDetails ['company'] . '</company>';
		}
			$dom = SplitDomain ( $_POST ['domain'] );
			if ($dom ['tld'] == 'us') {
				$nex = '<us_nexus>' . CleanInput ( $_POST ['us_nexus'], 'text' ) . '</us_nexus>
		<us_purpose>' . CleanInput ( $_POST ['us_purpose'], 'text' ) . '</us_purpose>';
			}
			
			$processorder .= $nex . '	</domaindetails>
	';
		
		
		$processorder .= $fraudresultxml;
		$productprices = '<nixbill>
	<command>GetProductPrices</command> 
	<productid>' . CleanInput ( $_POST ['productid'], 'numeric' ) . '</productid>
	<cycleid>' . CleanInput ( $_POST ['cycleid'], 'numeric' ) . '</cycleid>
</nixbill>';
		for($pk = 0; $pk < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] ); $pk ++) {
			if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$pk] ['ID'] [0] ['VALUE'] == CleanInput ( $_POST ['productid'], 'numeric' )) {
				$productkey = $pk;
			}
		}
		for($ck = 0; $ck < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] ); $ck ++) {
			if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$ck] ['ID'] [0] ['VALUE'] == CleanInput ( $_POST ['cycleid'], 'numeric' )) {
				$cyclekey = $ck;
			}
		}
		$product ['name'] = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['NAME'] [0] ['VALUE'];
		$product ['cycle'] = GetCycleName ( CleanInput ( $_POST ['cycleid'], 'numeric' ) );
		$product ['price'] = _money_format ( $fmt, $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$cyclekey] ['PRICE'] [0] ['VALUE'] );
		$product ['setup'] = _money_format ( $fmt, $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['CYCLES'] [0] ['CYCLE'] [$cyclekey] ['SETUP'] [0] ['VALUE'] );
		$processorder .= '	<orderdetails>
		<productid>' . CleanInput ( $_POST ['productid'], 'numeric' ) . '</productid>
		<cycleid>' . CleanInput ( $_POST ['cycleid'], 'numeric' ) . '</cycleid>
		<price>' . $product ['price'] . '</price>
		<setup>' . $product ['setup'] . '</setup>';
		
		if ($_POST ['domaintype'] == 'owned') {
			$processorder .= '		<domainsld></domainsld>
			<domaintld></domaintld>
			<domain>' . CleanInput ( $_POST ['domain'], 'text' ) . '</domain>';
		
		} else {
			
			$primaryDomain = SplitDomain ( CleanInput ( $_POST ['domain'], 'text' ) );
			$processorder .= '		<domainsld>' . $primaryDomain ['sld'] . '</domainsld>
			<domaintld>' . $primaryDomain ['tld'] . '</domaintld>';
		
		}
		if(strtoupper(CleanInput ( $_POST ['couponcode'], 'text' )) == "FREEDOMAIN" && $_POST['domaintype'] == 'owned'){
			$_POST ['couponcode'] = '';
		}
		$processorder .= '		<couponcode>' . CleanInput ( $_POST ['couponcode'], 'text' ) . '</couponcode>';
		$processorder .= '	</orderdetails>';
		
		if (is_array ( $_POST ['addoncycle'] )) {
			foreach ( $_POST ['addoncycle'] as $groupname => $group ) {
				if (is_array ( $group ))
					foreach ( $group as $ak => $av ) {
						if (is_numeric ( $av ['cycle'] )) {
							for($addk = 0; $addk < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] ); $addk ++) {
								if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$addk] ['ADDON'] [0] ['ID'] [0] ['VALUE'] == $ak) {
									$groupkey = $addk;
								}
							}
							for($ck = 0; $ck < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] ); $ck ++) {
								if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$ck] ['ID'] [0] ['VALUE'] == $ak) {
									$addonkey = $ck;
								}
							}
							for($ck = 0; $ck < count ( $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] ); $ck ++) {
								if ($result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$ck] ['ID'] [0] ['VALUE'] == $av ['cycle']) {
									$addoncyclekey = $ck;
								}
							}
							
							if ($_POST ['addon'] [$groupname] == $ak) {
								$processorder .= '	<orderdetails>
					<productid>' . $ak . '</productid>
					<cycleid>' . $av ['cycle'] . '</cycleid>
					<price>' . $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$addoncyclekey] ['PRICE'] [0] ['VALUE'] . '</price>
					<setup>' . $result ['NIXBILL'] [0] ['RESULT'] [0] ['PRODUCT'] [$productkey] ['ADDONS'] [0] ['GROUP'] [$groupkey] ['ADDON'] [$addonkey] ['CYCLES'] [0] ['CYCLE'] [$addoncyclekey] ['SETUP'] [0] ['VALUE'] . '</setup>
					<couponcode>' . CleanInput ( $_POST ['couponcode'], 'text' ) . '</couponcode>
				</orderdetails>';
							}
						}
					}
			}
			$this->AddTemplateVar ( 'addons', $addon );
			$addon = true;
		}
		
		if (CleanInput ( $_POST ['cycleid'], 'numeric' ) >= $this->Cfg ['freedomain'] && ! empty ( $this->Cfg ['freedomain'] )) {
			$freedomain = true;
		}
		$tldarray = $result ['NIXBILL'] [0] ['RESULT'] [0] ['TLDS'] [0] ['TLD'];
		if (is_array ( $_POST ['domains'] ) && $_POST ['domaintype'] == 'new') {
			foreach ( $_POST ['domains'] as $name => $cycle ) {
				$domainSplit = SplitDomain ( $name );
				for($ftk = 0; $ftk < count ( $tldarray ); $ftk ++) {
					if ($tldarray [$ftk] ['EXT'] [0] ['VALUE'] == $domainSplit ['tld'])
						$tldkey = $ftk;
				}
				if (is_array ( $tldarray [$tldkey] ['CYCLES'] [0] ['CYCLE'] )) {
					foreach ( $tldarray [$tldkey] ['CYCLES'] [0] ['CYCLE'] as $tk => $tv ) {
						if ($tv ['ID'] [0] ['VALUE'] == $cycle) {
							$tld = $tv;
						}
					}
				}
				if ($domainSplit ['tld'] == 'us') {
					$this->AddTemplateVar ( 'us_domain', '1' );
					$this->AddTemplateVar ( 'domainextra', '1' );
				}
				if ($domainSplit ['tld'] == 'co.uk') {
					$this->AddTemplateVar ( 'couk_domain', '1' );
					$this->AddTemplateVar ( 'domainextra', '1' );
				}
				if (is_numeric ( $cycle )) {
					if ($freedomain) {
						$tld ['PRICE'] [0] ['VALUE'] = 0;
						$freedomain = false;
					}
					
					$processorder .= '	<orderdetails>
					<productid>' . $tldarray [$tldkey] ['ID'] [0] ['VALUE'] . '</productid>
					<cycleid>' . $tld ['ID'] [0] ['VALUE'] . '</cycleid>
					<price>' . $tld ['PRICE'] [0] ['VALUE'] . '</price>
					<setup>' . $tld ['SETUP'] [0] ['VALUE'] . '</setup>
					<couponcode>' . CleanInput ( $_POST ['couponcode'], 'text' ) . '</couponcode>
					<domainsld>' . $domainSplit ['sld'] . '</domainsld>
					<domaintld>' . $domainSplit ['tld'] . '</domaintld>
				</orderdetails>';
				}
			}
			$this->AddTemplateVar ( 'domains', $domain );
		}
		$processorder .= '</nixbill>';
		
		$result = $this->API ( $processorder );
		
		$clientid = $result ['NIXBILL'] [0] ['RESULT'] [0] ['CLIENTID'] [0] ['VALUE'];
		$invoiceid = $result ['NIXBILL'] [0] ['RESULT'] [0] ['INVOICE'] [0] [INVOICEID] [0] [VALUE];
		$total = $result ['NIXBILL'] [0] ['RESULT'] [0] ['INVOICE'] [0] [TOTAL] [0] [VALUE];
		$setup = $result ['NIXBILL'] [0] ['RESULT'] [0] ['INVOICE'] [0] [SETUP] [0] [VALUE];
		$tax = $result ['NIXBILL'] [0] ['RESULT'] [0] ['INVOICE'] [0] [TAX] [0] [VALUE];
		$subtotal = $result ['NIXBILL'] [0] ['RESULT'] [0] ['INVOICE'] [0] [SUBTOTAL] [0] [VALUE];
		$grandtotal = $result ['NIXBILL'] [0] ['RESULT'] [0] ['INVOICE'] [0] [GRANDTOTAL] [0] [VALUE];
		$paymenttype = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] [PAYMENTTYPE] [0] [VALUE];
		
		$this->AddTemplateVar ( 'clientid', $clientid );
		$this->AddTemplateVar ( 'invoiceid', $invoiceid );
		$this->AddTemplateVar ( 'total', $total );
		$this->AddTemplateVar ( 'setup', $setup );
		$this->AddTemplateVar ( 'tax', $tax );
		$this->AddTemplateVar ( 'subtotal', $subtotal );
		$this->AddTemplateVar ( 'grandtotal', $grandtotal );
		$this->AddTemplateVar ( 'paymenttype', $paymenttype );
		$this->AddTemplateVar ( 'title', $orderformdetails ['NIXBILL'] [0] ['RESULT'] [0] ['ORDERFORMDETAILS'] [0] ['TITLE'] [0] ['VALUE'] );
		
		switch ($paymenttype) {
			case 1 :
				$billingaccountid = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['BILLINGACCOUNTID'];
				$transactionid = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['TRANSID'];
				$transactionstatus = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['STATUS'];
				$avs = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['AVS'];
				$cvv2 = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['CVV2'];
				$authcode = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['AUTHCODE'];
				$message = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['MESSAGE'];
				$rebid = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['TRANSACTIONINFO'] [0] ['ATTRIBUTES'] ['REBID'];
				$this->AddTemplateVar ( 'billingaccountid', $billingaccountid );
				$this->AddTemplateVar ( 'transactionid', $transactionid );
				$this->AddTemplateVar ( 'transactionstatus', $transactionstatus );
				$this->AddTemplateVar ( 'avs', $avs );
				$this->AddTemplateVar ( 'authcode', $authcode );
				$this->AddTemplateVar ( 'message', $message );
				$this->AddTemplateVar ( 'rebid', $rebid );
				if ($transactionstatus == 1) {
					$template = ORDERCOMPLETED;
					
					
					$this->AddTemplateVar( 'domain_name', $domain );
					$this->AddTemplateVar ( 'referer', $_POST ['referer'] );
					
				} else {
					$template = ORDERFAILED;
				}
				break;
			case 2 :
				$paypallinks = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['PAYPALLINKS'] [0] ['PAYPALLINK'];
				$onetime = $result ['NIXBILL'] [0] ['RESULT'] [0] ['PROCESSPAYMENT'] [0] ['PAYPALONETIMELINK'] [0] ['VALUE'];
				$this->AddTemplateVar ( 'paypalonetime', base64_decode ( $onetime ) );
				if (is_array ( $paypallinks )) {
					foreach ( $paypallinks as $link ) {
						$paypaldecodedlinks [] = base64_decode ( $link ['VALUE'] );
					}
				}
				$this->AddTemplateVar ( 'paypallinks', $paypaldecodedlinks );
				$template = ORDERCOMPLETEDPAYPAL;
				break;
			case 3 :
				break;
		}
		if (empty ( $template )) {
			$template = ORDERCOMPLETEDFREE;
		}
		$this->Log_SetOrdered($transactionstatus);
		$this->Display ( $template );
	}
	protected function SetErrors($errors) {
		$this->paymenterrors = $errors;
	}
	protected function GetErrors() {
		return $this->paymenterrors;
	}
	protected function SetDomainInformation($d) {
		$this->DomainInformation = $d;
	}
	protected function GetDomainInformation() {
		return $this->DomainInformation;
	}
	private $DomainInformation = array ();
}
$go = new products ( );
$go->Process ();
exit ();
?>